require 5.004;
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::Auth.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::Auth ();
use Satsuki::Auth_auto ();
package Satsuki::Auth;
###############################################################################
# 桼δ
###############################################################################
#-------------------------------------------------------------------------------
# 桼ꥹȤ
#-------------------------------------------------------------------------------
sub load_userlist {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{admin}) { $ROBJ->message('Operation not permitted'); return 1; }

	my $ROBJ    = $self->{ROBJ};
	my $userdb  = $self->load_userdb();
	my @uid_ary = sort(keys(%$userdb));
	my @ary;
	foreach(@uid_ary) {
		my %h = %{ $userdb->{$_} };
		undef $h{pass};
		push(@ary, \%h);
	}
	return \@ary;
}

#-------------------------------------------------------------------------------
# 桼ɲ
#-------------------------------------------------------------------------------
sub user_add {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{admin}) { $ROBJ->message('Operation not permitted'); return 1; }

	my $userdb = $self->load_userdb();
	my $id     = $form->{id};
	if ($id =~ /\W/) {
		my $AZ = ''; if (! $self->{uid_lower_rule}) { $AZ=' A-Z,'; }
		$ROBJ->message("ID's character allowed %s only", "'0-9',$AZ 'a-z', '_'");
		return 1;
	}
	$ROBJ->{Message_flag} = 0;	# åե饰ν

	$id =~ s/\W//g;
	if (exists $userdb->{$id}) { $ROBJ->message("ID '%s' already exists", $id); }
	if ($form->{pass} eq '')   { $ROBJ->message('Password is empty');   }

	$form->{id}          = $id;
	$form->{add}         = 1;
	$form->{change_pass} = 0;
	return $self->edit_userdb($form);	# ¹
}

#-------------------------------------------------------------------------------
# 桼Խ
#-------------------------------------------------------------------------------
sub user_edit {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{admin}) { $ROBJ->message('Operation not permitted'); return 1; }

	$ROBJ->{Message_flag} = 0;	# åե饰ν
	$form->{add}          = 0;
	$form->{change_pass}  = 0;
	return $self->edit_userdb($form);	# ¹
}

#-------------------------------------------------------------------------------
# 
#-------------------------------------------------------------------------------
sub user_delete {
	my ($self, $delete_ary) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{admin}) { $ROBJ->message('Operation not permitted'); return 1; }
	if (ref $delete_ary ne 'ARRAY') { $ROBJ->message('No assignment delete user'); return 1; }

	return $self->edit_userdb(undef, $delete_ary);	# ¹
}

#-------------------------------------------------------------------------------
# ѥɤѹʥ桼ܿ͡
#-------------------------------------------------------------------------------
sub change_pass {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{ok})       { $ROBJ->message('No login');                   return 1; }
	if ($self->{auto})       { $ROBJ->message("Can't execute with 'root*'"); return 1; }
	if ($form->{pass} eq '') { $ROBJ->message('New password is empty');      return 1; }

	my $id = $self->{id};
	my $cur_pass = $self->load_userdb()->{$id}->{pass};
	if (! $self->check_pass($cur_pass, $form->{now_pass})) {
		$ROBJ->message('Incorrect password'); return 1;
	}

	my %h;
	$ROBJ->{Message_flag} = 0;	# åե饰ν
	$h{id}           = $id;
	$h{add}          = 0;
	$h{change_pass}  = 1;
	$h{pass}         = $form->{pass};
	$h{pass2}        = $form->{pass2};
	return $self->edit_userdb( \%h );	# ¹
}

#-------------------------------------------------------------------------------
# 桼̾ѹʥ桼ܿ͡
#-------------------------------------------------------------------------------
sub change_user_name {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{ok})       { $ROBJ->message('No login');                   return 1; }
	if ($self->{auto})       { $ROBJ->message("Can't execute with 'root*'"); return 1; }

	my $id = $self->{id};
	my $cur_pass = $self->load_userdb()->{$id}->{pass};
	if (! $self->check_pass($cur_pass, $form->{now_pass})) {
		$ROBJ->message('Incorrect password'); return 1;
	}

	# 桼̾γǧ
	$form->{name} =~ s/\s*([^\s]*)\s*/$1/;	# ζ

	my %h;
	$ROBJ->{Message_flag} = 0;	# åե饰ν
	$h{id}           = $id;
	$h{add}          = 0;
	$h{change_name}  = 1;
	$h{name}         = $form->{name};
	return $self->edit_userdb( \%h );	# ¹
}

#-------------------------------------------------------------------------------
# 桼ղþѹ
#-------------------------------------------------------------------------------
sub set_user_info {
	my ($self, $info, $id) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{ok}) { $ROBJ->message('No login');                   return 1; }
	if ($self->{auto}) { $ROBJ->message("Can't execute with 'root*'"); return 1; }

	$id =~ s/\W//g;
	if (!$self->{admin} || $id eq '') { $id = $self->{id}; }

	my %h;
	$ROBJ->{Message_flag} = 0;	# åե饰ν
	$h{id}           = $id;
	$h{add}          = 0;
	$h{change_info}  = 1;
	$h{info}         = $info;
	return $self->edit_userdb( \%h );	# ¹
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# 桼ǡ١ν񤭴
#------------------------------------------------------------------------------
sub edit_userdb {
	my ($self, $form, $del_users) = @_;
	my $ROBJ   = $self->{ROBJ};
	my $userdb = $self->load_userdb();
	if (ref $del_users ne 'ARRAY') { $del_users = []; } # ARRAY

	my %edit;
	if (ref $form eq 'HASH') {
		my $id = $form->{id};
		if (!$form->{add} && !exists $userdb->{$id}) { $ROBJ->message("Can't find ID"); }
		$id =~ s/\W//g;
		if ($id eq '')    { $ROBJ->message('ID is empty');  }
		if ($self->{uid_lower_rule}) {
			if    ($id =~ /^[A-Z]/) { $ROBJ->message("Don't use upper case in ID"); }
			elsif ($id =~ /^[\d_]/) { $ROBJ->message("ID first character must be between a to z"); }
		}
		if (length($id) > $self->{uid_max_length}) { $ROBJ->message("Too long ID (max %d)", $self->{uid_max_length}); }
		$edit{id} = $id;
		if ($form->{change_pass}) {
			$edit{name}    = $userdb->{$id}->{name};
			$edit{admin}   = $userdb->{$id}->{admin};
			$edit{disable} = $userdb->{$id}->{disable};
			$edit{info}    = $userdb->{$id}->{info};
		} elsif ($form->{change_name}) {
			$edit{name}    = $form->{name};
			$edit{admin}   = $userdb->{$id}->{admin};
			$edit{disable} = $userdb->{$id}->{disable};
			$edit{info}    = $userdb->{$id}->{info};
		} elsif ($form->{change_info}) {
			$edit{name}    = $userdb->{$id}->{name};
			$edit{admin}   = $userdb->{$id}->{admin};
			$edit{disable} = $userdb->{$id}->{disable};
			$edit{info}    = $form->{info};
		} else {
			$edit{name}    = $form->{name};
			$edit{info}    = $form->{info};
			$edit{admin}   = $form->{admin};
			$edit{disable} = $form->{disable};
			$edit{name}    =~ s/[\r\n\t\0\"\'<>]//g;
			$edit{info}    =~ s/[\r\n\t\0\"\'<>]//g;
			$edit{admin}  +=0;
		}
		# 桼̾γǧ
		my $name = $edit{name};
		if ($name eq '') { $ROBJ->message('Name is empty'); }
		if ($self->{name_notag} && $name =~ /[\"\'<>]/) { $ROBJ->message('Name not allow ", \', <, > charcteor'); }
		if (length($name) > $self->{name_max_length})   { $ROBJ->message("Too long name (max %d)", $self->{name_max_length}); }

		#if ($form->{disable}) { $edit{pass} = '*'; }	# 桼̵
		if ($form->{pass} eq '') {	# ѥɤѹʤ
			$edit{pass} = $userdb->{$id}->{pass};
		} else {			# ѥɤѹ
			if (length($form->{pass}) < $self->{pass_min}) {
				$ROBJ->message("Too short password (min %d)", $self->{pass_min});
			} elsif (defined $form->{pass2} && $form->{pass} ne $form->{pass2}) {
				$ROBJ->message("Mismatch password and retype password");
			} else {
				$edit{pass} = $self->encrypt_pass($form->{pass});
			}
		}
		delete $userdb->{$id};	# 줿ϥåƤ
	}

	# 顼
	if ($ROBJ->{Message_flag}) { return 2; }	# 顼ä

	# եɤ߹ߡԽѡ
	my $userdb_file  = $self->{userdb_file};
	if (substr($userdb_file,0,1) ne '/') { $userdb_file = $self->{dir} . $userdb_file; }
	my ($fh, $lines) = $ROBJ->fedit_readlines($userdb_file);
	my $userdb       = $self->set_userdb($lines);

	# 
	foreach(@$del_users) {
		if (exists $userdb->{$_}) {
			delete $userdb->{$_};
			# å
			$ROBJ->file_delete($self->{dir} . $_ . $self->{file_ex});
			$ROBJ->file_delete($self->{dir} . $_ . "-fail" . $self->{file_ex});
		}
	}

	# Խ
	if ($edit{id} ne '') { $userdb->{$edit{id}} = \%edit; }

	# ե˽᤹
	my @keys = sort {$a cmp $b} keys(%$userdb);
	my @newlines;
	foreach (@keys) {
		my $u = $userdb->{$_};
		push(@newlines, "$_\t$u->{pass}\t$u->{admin}\t$u->{name}\t$u->{disable}\t$u->{info}\n");
	}
	$ROBJ->fedit_writelines($userdb_file, $fh, \@newlines);
	if (defined $self->{message}) { $ROBJ->message( $self->{message} ); }	# å
	return 0;
}

#------------------------------------------------------------------------------
# ѥɤŹ沽
#------------------------------------------------------------------------------
sub encrypt_pass {
	my ($self, $pass) = @_;
	return crypt($pass, $self->get_salt() );
}

#------------------------------------------------------------------------------
# SALTʸ
#------------------------------------------------------------------------------
sub get_salt {
	my ($self) = @_;
	my @ip   = split(/\./, $ENV{REMOTE_ADDR});
	my $ipb  = int(rand( $ip[0]*313 + $ip[1]*3 + $ip[2]*97 + $ip[3]*941 ))
		 + int(rand( 134123 ));
	my $salt = $self->{ROBJ}->{Salt64chars};
	return substr($salt, $ipb & 63, 1) . substr($salt, ($ipb >> 6) & 63, 1);
}

1;	# ޤʤ
