use strict;
#------------------------------------------------------------------------------
# buffer եǡɤ߹ߥ롼
#						(C)2006-04 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Base::BufferedRead;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
my $boundary_max        =  1024;	# κĹ
my $buffer_size_default = 65536;	# ХåեΥǥե
#  $boundary_max <= $buffer_size_default Ǥ뤳ȡ
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	$self->{ROBJ}        = shift;
	$self->{fh}          = shift || 'STDIN';	# ǡɤ߽Ф FileHandle
	$self->{read_size}   = 0;			# ɤ߽Ф
	$self->{read_max}    = (shift) +0;		# ɤ߹
	$self->{buffer_size} = shift || $buffer_size_default;
	if ($self->{buffer_size} > $self->{read_max}) {
		$self->{buffer_size} = $self->{read_max};
	}
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ǡɤ߽Ф
#------------------------------------------------------------------------------
# buffer_size = boundary_size ξưå (2006/4/22)
#
sub read_line {
	my $self = shift;
	my ($output, $boundary, $output_max_size) = @_;
	# ϥǡå
	my $boundary_size = length($boundary);
	if ($boundary_size == 0 || $boundary_size > $boundary_max) { return ; }
	my $output_is_file;
	if (ref($output) ne 'SCALAR' && ($output eq '' || !fileno($output))) { $output = \( $_[0] ); }
	if (ref($output) eq 'SCALAR') { $$output = ''; }

	# Ϻ祵
	if ($output_max_size eq '') { $output_max_size = 0x10000; }		# 1MB

	# buffer ξɤ߹
	my $read_size = $self->{read_size};
	my $read_max  = $self->{read_max};
	my $buf       = $self->{buffer};
	my $offset    = $self->{buffer_offset};
	my $fh        = $self->{fh};
	my $buf_size  = $self->{buffer_size}+0;
	if ($buf_size < $boundary_max) { $buf_size = $buffer_size_default; }

	my $out_size_total;
	while (1) {
		my $find = index($buf, $boundary, $offset);
		if ($find >= 0) {
			my $size  = $find - $offset;
			&output($output, \$out_size_total, $output_max_size, $buf, $offset, $size);
			$offset  += $size + $boundary_size;		# ɤ߹ʬ餹
			last;
		}
		#-------------------------------------------
		# buffer ˤʤä
		#-------------------------------------------
		# ǡ⤹٤ɤ߽
		if ($self->{file_eof}) {
			my $size = length($buf) - $offset;
			&output($output, \$out_size_total, $output_max_size, $buf, $offset, $size);
			$self->{data_end}=1;
			last;
		}
		# 鶭-1 ʬĤƽ
		my $read_buf_offset = 0;
		if ($buf ne '') {
			my $size = $buf_size - $offset;
			if ($size >= $boundary_size-1) {
				# Ĥꥵ >= ʸ󥵥-1
				$read_buf_offset = $boundary_size-1;	# ʸ󥵥-1 򤺤餷ƻĤ
				$size -= $boundary_size-1;		# ʸ󥵥-1 Ĥƽ
			} else {
				# Ĥꥵ <  ʸ󥵥-1
				$read_buf_offset = $size;		# Ĥꥵʬ٤Ƥ򤺤餷ƻĤ
				$size  = 0;				# Ϥʤ
			}
			&output($output, \$out_size_total, $output_max_size, $buf, $offset, $size);
			substr($buf, 0, $read_buf_offset) = substr($buf, -$read_buf_offset);	# Ƭcopy
			$offset = 0;
		}
		# buffer ɲɤ߹
		my $try_read_size = $buf_size - $read_buf_offset;
		if ($read_max && ($read_max < $read_size + $try_read_size)) {	# 祵 < ɤ߽Ф
			$try_read_size = $read_max - $read_size;
		}
		my $read_bytes = read($fh, $buf, $try_read_size, $read_buf_offset);
		$read_size += $read_bytes;
		# file eof  ɤ߹̤ޤɤ߹
		if (($read_bytes+$read_buf_offset) < $buf_size || ($read_max && $read_max <= $read_size)) {
			$self->{file_eof} = 1;
		}
	}
	# ͤ¸
	$self->{buffer}        = $buf;
	$self->{buffer_offset} = $offset;
	$self->{read_size}     = $read_size;
	return $out_size_total;
}

#-----------------------------------------------------------
# ǡϤ
#-----------------------------------------------------------
sub output {
	my ($output, $out_size, $out_max_size, $buf, $offset, $size) = @_;
	my $new_out_size = $$out_size + $size;
	if ($new_out_size > $out_max_size) {
		$size = $size - ($new_out_size - $out_max_size);
	}
	if ($size < 1) { return $$out_size; }	# 0ʲʤϤ return
	if (ref($output) eq 'SCALAR') {
		$$output .= substr($buf, $offset, $size);
	} else {
		syswrite($output, $buf, $size, $offset);
	}
	return ($$out_size += $size);		# ߷׽ϥ
}


1;
