use strict;
#------------------------------------------------------------------------------
# Split from Base.pm for AutoLoader
#------------------------------------------------------------------------------
use Satsuki::Base ();
package Satsuki::Base;
my $action_skelton_subdir = 'action/';
###############################################################################
# ȥ󥭥å
###############################################################################
#------------------------------------------------------------------------------
# åΥ
#------------------------------------------------------------------------------
sub save_cache {
	my ($self, $cache_file, $src_file, $src_file_tm, $arybuf) = @_;
	my @lines;
	push(@lines, <<TEXT);
# $self->{Timestamp} : Generate from '$src_file';
#------------------------------------------------------------------------------
# Caution) Don't edit this file . If you edit this, will be occoued error.
#------------------------------------------------------------------------------
\0
TEXT
	# С󡿥ѥ顦ȥι
	push(@lines, "Version = 1.01\n\0");
	push(@lines, ($self->{Compiler_tm}) . "\0");
	push(@lines, $src_file_tm . "\0");

	# 롼¸
	push(@lines, ($#$arybuf+1) . "\0");
	foreach (@$arybuf) {
		push(@lines, "$_\0");	# routines
	}
	# ͽΰ
	push(@lines, "0\0");
	push(@lines, "0\0");
	push(@lines, "0\0");

	# ե˽񤭽Ф
	$self->fwrite_lines($cache_file, \@lines, $self->{File_mode} || 0666);
}

###############################################################################
# λ̿
###############################################################################
#-------------------------------------------------------------------------------
# λեå롼Ͽ
#-------------------------------------------------------------------------------
sub regist_endhook {
	my $self  = shift;
	my $level = shift;
	my $func  = shift;

	my $endhook_list = $self->{Endhook_list};
	if ($endhook_list eq 'end') { return; }		# ̵¥롼ɻ
	if (!ref $endhook_list) {			# array ref 
		 $self->{Endhook_list} = $endhook_list = [];
	}

	my %h;
	$h{level} = $level;
	$h{func}  = $func;
	$h{arg}   = \@_;	# ԡ
	push(@$endhook_list, \%h);
}

#------------------------------------------------------------------------------
# 顼ˤ뽪λ
#------------------------------------------------------------------------------
sub error_exit {
	my ($self, $err) = @_;
	my ($pack, $file, $line) = caller(1);
	# HTTP mode
	if (substr($ENV{SERVER_PROTOCOL}, 0, 4) eq 'HTTP') {
		$err =~ s/\n/<br>\n/g;
		$self->print_content_type('text/html');
		print <<HTML;
<html><body>
<h1>Perl interpreter error (exit)</h1>
<p><span style="font-family: monospace;">$err</p>
<!-- $file at $line -->
</body></html>
HTML
	} else {
		$err =~ s/&lt;/>/g;
		$err =~ s/&gt;/>/g;
		$err =~ s/&quot;/"/g;
		print "*** Perl interpreter error (exit) ***\n$err\n";
	}
	$self->{Error} = undef;
	$self->exit(-1);	# λ
}

###############################################################################
# ȥcall
###############################################################################
#------------------------------------------------------------------------------
# actionθƤӽФ
#------------------------------------------------------------------------------
sub call_action {
	my ($self, $action) = @_;
	$action =~ s/\W//g;	# ɻ
	if ($action eq '') { return ; }
	my $skelton_name = $action_skelton_subdir . $action;
	my ($action_file, $dummy, $skel_level) = $self->check_skelton( $skelton_name );
	if (!defined $action_file) { return ; }		# ե뤬ʤ

	my $r;
	local ($self->{__cont_level});
	$self->{__cont_level} = $skel_level -1;
	if (defined ($r = $self->__call($action_file, $skelton_name))) {
		$self->{Called_action} = $action;
	} else {
		$self->error("[call_ation] call '%s' faild", $action);
	}
	return $r;
}

#------------------------------------------------------------------------------
# ǥ쥯ȥΥȥƤӽФ
#------------------------------------------------------------------------------
sub call_dir {
	my ($self, $dir, $level) = splice(@_, 0, 3);
	my $file_ex = $self->{Skelton_file_ex};
	$dir =~ s|\.\.\/||g;
	$dir = $self->{Skelton_subdir} . $dir;
	my $files = $self->search_files( $self->{Skelton_dir} . $dir, $file_ex );
	# 桼ȥ⸡
	if (!defined $level) { $level=4; }
	if ($level>2 && $self->{User_skelton_dir3} ne '') {
		my $files2 = $self->search_files( $self->{User_skelton_dir3} . $dir, $file_ex);
		push(@$files, @$files2);
	}
	if ($level>1 && $self->{User_skelton_dir2} ne '') {
		my $files2 = $self->search_files( $self->{User_skelton_dir2} . $dir, $file_ex);
		push(@$files, @$files2);
	}
	if ($level>0 && $self->{User_skelton_dir}  ne '') {
		my $files2 = $self->search_files( $self->{User_skelton_dir}  . $dir, $file_ex);
		push(@$files, @$files2);
	}

	# 
	$files = [ sort(@$files) ];
	my $prev;
	my $file_ex_len = length($file_ex);
	my @ary;
	foreach(@$files) {
		if ($_ eq $prev) { next; }
		$prev = $_;
		my $file = $dir . substr($_, 0, length($_) - $file_ex_len);
		push(@ary, $self->call( $file, @_ ));
	}
	return \@ary;
}

###############################################################################
# ʸϥå
###############################################################################
#------------------------------------------------------------------------------
# η
#------------------------------------------------------------------------------
sub chain_array {
	my ($self, $ary, $str) = @_;
	$self->_chain_array($ary, \$str);
	return $str;
}
sub _chain_array {
	my ($self, $ary, $r_str) = @_;
	foreach(@$ary) {
		if (ref $_ eq 'ARRAY') {
			$self->_chain_array($_, $r_str);
		} else {
			$$r_str .= $_;
		}
	}
}
#------------------------------------------------------------------------------
# ʸĹå
#------------------------------------------------------------------------------
sub check_length {
	my ($self, $str, $name, $len) = @_;
	if (length($str) <= $len) { return ; }
	$self->message("Too long %s (max %d characters)", $name, $len);
}

#------------------------------------------------------------------------------
# ꤷϥå奭¸ߤȤΤߥԡ
#------------------------------------------------------------------------------
sub copy_with_key {
	my ($self, $hash, $ary) = @_;
	my %h;
	foreach(@$ary) {
		if (!exists $hash->{$_}) { next; }
		$h{$_} = $hash->{$_};
	}
	return \%h;
}

###############################################################################
# ʸʤ
###############################################################################
sub while_exec {
	my $self    = shift;
	my $skelton = shift;
	my @ary;
	my $count = 0;
	while($_[0] && $count<1000) {
		$self->{i} = ++$count;
		push(@ary, $self->execute($skelton));
	}
	return \@ary;
}

sub until_exec {
	my $self    = shift;
	my $skelton = shift;
	my @ary;
	my $count = 0;
	until($_[0] || $count>999) {
		$self->{i} = ++$count;
		push(@ary, $self->execute($skelton));
	}
	return \@ary;
}

###############################################################################
# ե
###############################################################################
#------------------------------------------------------------------------------
# ٤ƤιԤե˽񤭹
#------------------------------------------------------------------------------
# &fwrite_lines($file, $array_ref);
# Ret:	0	
# 	1	
sub fwrite_lines {
	my $self = shift;
	my ($file, $lines, $mode, $append_flag) = @_;
	my $_file = $self->get_filepath($file);
	if (ref $lines ne 'ARRAY') { $lines = [$lines]; }

	my $fail_flag = 0;
	my $fh; # = Symbol::gensym();
	if ( !sysopen($fh, $_file, O_CREAT | O_RDWR | $append_flag) ) { $self->error("File can't write '%s'", $file); $fail_flag=1; }
	binmode($fh);
	$self->lock($_file, $fh);
	if (! ($append_flag & O_APPEND)) {	# ɵ⡼ɤǤϤʤ
		truncate($fh, 0);		# ե륵 0 
		seek($fh, 0, 0);		# եݥ󥿤Ƭ
	}
	$self->_output_array($lines, $fh);
	close($fh);
	$self->unlock($_file);

	# ⡼ѹ
	if (!defined $mode) { $mode = $self->{File_mode};   }
	if ( defined $mode) { my $r = chmod($mode, $_file); }

	return $fail_flag;
}

#------------------------------------------------------------------------------
# ե롧եɵ
#------------------------------------------------------------------------------
# &fappend_lines($file, \@ary, $mode);
sub fappend_lines {
	my $self = shift;
	return $self->fwrite_lines(@_[0,1,2], O_APPEND);
}

#------------------------------------------------------------------------------
# ե롧եԽ
#------------------------------------------------------------------------------
# Խѡåդ
# ($fh, $ary_ref) = fedit_readlines($file);
#	$fh		file handle
#	$ary_ref	array reference
sub fedit_readlines {
	my $self = shift;
	my ($file, $lines) = @_;
	my $_file = $self->get_filepath($file);

	my $fh; # = Symbol::gensym();
	if ( !sysopen($fh, $_file, O_CREAT | O_RDWR) ) { $self->error("File can't read (for edit) '%s'", $file); }
	binmode($fh);
	$self->lock($_file, $fh);
	my @lines = <$fh>;
	return ($fh, \@lines);
}

# fedit_writelines($file, $fh, $ary_ref);
#	$file		file name
#	$fh		file handle
#	$ary_ref	array reference
sub fedit_writelines {
	my $self = shift;
	my ($file, $fh, $lines, $mode) = @_;
	if (ref $lines ne 'ARRAY') { $lines = [$lines]; }

        truncate($fh, 0);		# ե륵 0 
	seek($fh, 0, 0);		# եݥ󥿤Ƭ
	foreach(@$lines) {
		print $fh $_;
	}
	close($fh);
	my $_file = $self->get_filepath($file);
	$self->unlock( $file );

	# ⡼ѹ
	if (!defined $mode) { $mode = $self->{File_mode};   }
	if ( defined $mode) { my $r = chmod($mode, $_file); }
	return 0;
}

sub fedit_exit {
	my $self = shift;
	my ($file, $fh) = @_;
	close($fh);
	$self->unlock( $self->get_filepath($file) );
}

#------------------------------------------------------------------------------
# ե롧ɸϥåɵ
#------------------------------------------------------------------------------
# &fappend_hash($file, \%h);
sub fappend_hash {
	return &_fwrite_hash($_[0], O_APPEND, @_[1,2,3]);
}
sub fwrite_hash {
	return &_fwrite_hash($_[0], 0, @_[1,2,3]);
}

sub _fwrite_hash {
	my $self = shift;
	my ($append_flag, $file, $h, $mode) = @_;

	my @ary;
	# if ($append_flag) { push(@ary, "**\n"); }
	while(my ($key, $val) = each(%$h)) {
		if (ref $val || (!$append_flag && $val eq '')) { next; }
		$key =~ s/[\r\n=\*]//g;	# 
		if ($val =~ /\n/) {	# ͤ˲Ԥޤ
			$val =~ s/__END_BLK_DATA\n/__END_BLK_DATA \n/g;
			push(@ary, "*$key=<<__END_BLK_DATA\n$val\n__END_BLK_DATA\n");
		} else {
			push(@ary, "$key=$val\n");
		}
	}
	if ($file eq '') { return \@ary; }
	return $self->fwrite_lines($file, \@ary, $mode, $append_flag);
}
#------------------------------------------------------------------------------
# ե롧ɸϥåΥǥå
#------------------------------------------------------------------------------
sub fedit_readhash {
	my ($self, $file) = @_;
	my ($fh, $lines) = $self->fedit_readlines($file);
	my $hash = $self->fread_hash($lines);
	return ($fh, $hash);
}
sub fedit_writehash {
	my ($self, $file, $fh, $hash) = @_;
	my $lines = $self->_fwrite_hash(0, undef, $hash);
	$self->fedit_writelines($file, $fh, $lines);
}

#-----------------------------------------------------------
# lock unlockƤӽФ (for write)
#-----------------------------------------------------------
sub lock {
	my ($self, $file, $file_handle) = @_;
	if (defined $self->{Lock}) {
		return $self->{Lock}->lock($file, $file_handle);
	}
	flock($file_handle, 2);		# block lock for wirte
}
sub unlock {
	my ($self, $file) = @_;
	if (defined $self->{Lock}) {
		$self->{Lock}->unlock($file);
	}
}

###############################################################################
# ¾եϢ
###############################################################################
#------------------------------------------------------------------------------
# ǥ쥯ȥκ
#------------------------------------------------------------------------------
sub mkdir {
	my ($self, $dir, $mode) = @_;
	$dir = $self->get_filepath($dir);
	if (-e $dir) { return -1; }
	my $r = mkdir( $dir );	# 0:fail 1:Success
	if ($r) {
		if (substr($dir,-1) eq '/') { chop($dir); }
		if (!defined $mode) { $mode = $self->{Dir_mode}; }
		if ( defined $mode) { $r = chmod($mode, $dir); }
	} else { $self->error("Failed mkdir '%s'", $_[1]); }
	return $r;
}

#------------------------------------------------------------------------------
# եκ
#------------------------------------------------------------------------------
sub file_delete {
	my $self = shift;
	return unlink( $self->get_filepath($_[0]) );
}

# rm -rf 
sub dir_delete {	# Ƶؿ
	my ($self, $dir) = @_;
	if ($dir eq '') { return; }
	if (substr($dir, -1) ne '/') { $dir .= '/'; }
	$dir = $self->get_filepath($dir);
	my $files = $self->search_files( $dir, '', 1 );
	foreach(@$files) {
		my $file = $dir . $_;
		if (-d $file) { $self->dir_delete( $file ); }
		  else { unlink( $file ); }
	}
	rmdir($dir);
}

#------------------------------------------------------------------------------
# եΥԡ
#------------------------------------------------------------------------------
sub copy_file {
	my ($self, $src, $des) = @_;
	$src = $self->get_filepath($src);
	$des = $self->get_filepath($des);
	return $self->_copy_file($src, $des)
}
sub _copy_file {
	my ($self, $src, $des) = @_;
	my $data;
	my $fh; # = Symbol::gensym();

	# READ
	if ( !sysopen($fh, $src, O_RDONLY) ) { $self->error("File can't read '%s'", $src); return 1; }
	$self->read_lock($src, $fh);
	my $size = (stat($fh))[7];
	read($fh, $data, $size);
	close($fh);
	$self->read_unlock($src);

	# Write
	if ( !sysopen($fh, $des, O_WRONLY | O_CREAT) ) { $self->error("File can't write '%s'", $des); return 2; }
	$self->lock($des, $fh);
	syswrite($fh, $data, $size);
	close($fh);
	$self->unlock($des);
	chmod($self->{File_mode}, $des);
	return 0;
}


#------------------------------------------------------------------------------
# ǥ쥯ȥȤ򥳥ԡ
#------------------------------------------------------------------------------
# cp -r src_dir/* new_dir
sub copy_dir {
	my ($self, $src, $des, $mode) = @_;
	$src = $self->get_filepath($src);
	$des = $self->get_filepath($des);
	if (substr($src, -1) ne '/') { $src .= '/'; }
	if (substr($des, -1) ne '/') { $des .= '/'; }
	return $self->_copy_dir($src, $des)
}
# Ƶؿ
sub _copy_dir {
	my ($self, $src, $des) = @_;
	$self->mkdir("$des/");
	chmod($self->{Dir_mode}, $des);
	my $files = $self->search_files( $src, '', 1 );
	my $error = 0;
	foreach(@$files) {
		my $file = $src . $_;
		if (-d $file) {
			$error += $self->_copy_dir( "$file/", "$des$_/" );
		} else {
			$error += $self->_copy_file($file, "$des$_") && 1;
		}
	}
	return $error;
}

#------------------------------------------------------------------------------
# ƥݥեκ
#------------------------------------------------------------------------------
# ˥ե̾ѿꤹ뤳
sub open_tmpfile {
	my $self     = shift;
	my $file_ref = shift;
	my $dir = $self->{Temp_dir};
	if ($dir eq '') {
		$dir =~ $ENV{TMPDIR} || $ENV{TEMP} || $ENV{TMP} || '/tmp';
		$dir =~ tr/\\/\//;		# for windows
		if ($dir eq '') { return ; }	# 
		$dir .= '/satsuki-system/';
	} else {
		$dir = $self->get_filepath( $dir );
	}
	# ǥ쥯ȥǧ
	if (!-w  && !$self->mkdir($dir)) {
		$self->error("Can't write temporary dir '%s'", $dir);
		return ;
	}
	# Ťƥݥκ
	my $timeout = int( $self->{Temp_timeout} ) || 30;
	if ($timeout > 600) { $timeout=600; }
	$self->tmpwatch( $dir, $timeout, 'atime' );

	# ƥݥեΥץ
	my $tmp_file_base = $dir . $$ . '_' . ($ENV{REMOTE_PORT} +0) . '_';
	my $fh; # = Symbol::gensym();
	my $file;
	my $i = 1;
	while($i<100) {
		$file = $tmp_file_base . $i . '.tmp';
		if (sysopen($fh, $file, O_CREAT | O_EXCL | O_RDWR)) {
			binmode($fh);
			$i=0; last;		# 
		}
		$i++;
	}
	if ($i) {	# 
		$self->error("Can't open temporary file '%s'", $file_ref);
		return ;
	}
	$$file_ref = $file;
	return $fh;
}
#------------------------------------------------------------------------------
# ƥݥեκ
#------------------------------------------------------------------------------
sub tmpwatch {
	my $self = shift;
	my ($dir, $time, $type) = @_;
	$dir = $self->get_filepath( $dir );
	if ($time < 5) { $time=5; }

	# 
	if    ($type eq 'atime') { $type= 8; }
	elsif ($type eq 'ctime') { $type=10; }
	else  { $type=9; }	# mtime (modified time)
	my $check_tm = $self->{TM} - $time;	# $check_tm Ťк

	# 롼
	my $files = $self->search_files( $dir );
	my $c = 0;
	foreach(@$files) {
		my $file = $dir . $_;
		if ((stat($file))[$type] > $check_tm) { next; }
		$c += unlink( $file );
	}
	return $c;
}

###############################################################################
# ƥå
###############################################################################
#------------------------------------------------------------------------------
# Υ饤֥꤬뤫å
#------------------------------------------------------------------------------
#Ret:	Ǥʤʸ	饤֥ؤΥѥ
#
sub check_pm {
	my $self = shift;
	my $pm   = 'Satsuki/' . shift;
	return $self->check_lib($pm, @_);
}
sub check_lib {
	my $self     = shift;
	my $lib_file = shift;
	if (index($lib_file, '.') < 0) { $lib_file .= ".pm"; }
	$lib_file =~ s|::|/|g;
	if ($INC{$lib_file}) { return $INC{$lib_file}; }
	foreach(@INC) {
		if (-r "$_/$lib_file") { return "$_/$lib_file"; }
	}
	return ;
}
###############################################################################
# νʸ
###############################################################################
sub tag_escape_for_xml {	# &nbsp; ϻȤʤ
	my $self = shift;
	foreach(@_) {
		$_ =~ s/&(\w+;|\#\d+;)/\x01$1/g;
		$_ =~ s/&/&amp;/g;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$_ =~ s/"/&quot;/g;
		$_ =~ tr/\x01/&/;
	}
	return $_[0];
}

sub delete_Wchar {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/\W//g;
	}
	return $_[0];
}

###############################################################################
# ꡼ե
###############################################################################
#------------------------------------------------------------------------------
# եɤ߹ߡʼΡ
#------------------------------------------------------------------------------
sub _read_form {
	my ($self) = @_;
	if ($ENV{REQUEST_METHOD} ne 'POST') { return ; }
	if (ref $self->{Form} eq 'HASH') { return $self->{Form}; }

	### POST ץȤ pre-exec 
	if ($self->{If_post_pre_exec}) { $self->execute( $self->{If_post_pre_exec} ); }
	### ץ
	my $options = $self->{Form_options};
	### ޥѡ form 
	my $content_type = $ENV{CONTENT_TYPE};
	if ($options->{allow_multipart} && index($content_type, 'multipart/form-data') >= 0) {
		return $self->read_multipart_form( $content_type );
	}
	### ǡγǧ
	my $length = $ENV{CONTENT_LENGTH};
	my $total_max = $options->{total_max_size};
	if ($total_max && $length > $total_max) {
		$self->message('Too large form data (max %dKB)', $total_max >> 10); return ;
	}
	### ̾Υե
	my $content;
	read(STDIN, $content, $ENV{CONTENT_LENGTH});
	my @form = split(/&/, $content);
	undef $content;

	### ե
	my $form = $self->{Form} = {};
	foreach (@form) {
		my ($name, $val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		# $val =~ tr/|/\xe1/;	# debug for XSS
		$self->form_data_check_and_save($form, $options, $name, $val);
	}

	# save
	$self->{POST} = 1;		# POST Ǥ뤳ȤϿ
	$self->{Form} = $form;

	# POST ץȤ exec 
	if ($self->{If_post_exec}) { $self->execute( $self->{If_post_exec} ); }
	return 1;
}

#------------------------------------------------------------------------------
# multipart եɤ߹ RFC1867, RFC2388
#------------------------------------------------------------------------------
sub read_multipart_form {
	my ($self, $content_type) = @_;
	my $options = $self->{Form_options};

	### ǡγǧ
	my $length    = $ENV{CONTENT_LENGTH};
	my $total_max = $options->{multipart_total_max_size};
	if ($total_max && $length > $total_max) {
		$self->message('Too large form data (max %dKB)', $total_max >> 10); return ;
	}

	my $file_max_size   = $options->{multipart_file_max_size} || $total_max || 0x100000;	#  1MB
	my $data_max_size   = $options->{multipart_data_max_size} || 0x10000;			# 64KB
	my $header_max_size = 1024;
	my $use_temp_dir    = $options->{multipart_use_temp_dir};

	# boundary ɤ߽Ф
	binmode(STDIN);		# for DOS/Windows
	$content_type =~ /boundary=(.*)/;
	my $boundary = $1;
	my $form     = {};
	my $buffer   = $self->loadpm('Base::BufferedRead', 'STDIN', $length, $options->{multipart_buffer_size});
	$buffer->{read_max} = $length;

	# Ƭ boundary ɤ߼Τ
	my $line;
	$buffer->read_line(\$line, "--$boundary\r\n", $header_max_size);
	$boundary = "\r\n--$boundary";
	# ɤ߽Ф롼
	my $err = 1;
	while(! $buffer->{data_end}) {
		# إåɤ߽Ф
		my $name;
		my $filename;
		my $count = 32;
		while($count--) {
			$buffer->read_line(\$line, "\r\n", $header_max_size);
			if ($line eq '') { last; }
			if ($line =~ /^Content-Disposition:(.*)$/i) {
				$line = $1;
				if ($line =~ /name=\"(.*?)\"/i)     { $name = $1; }
				if ($line =~ /filename=\"(.*?)\"/i) { $filename = $1; }
			}
		}
		if (!$count) { $err=2; last; }		# ʷ

		# ǡɤ߽Ф
		my $value;
		if (defined $filename) {
			# ե̾ùʥեѥΤȤե̾Τ߼Ф
			$filename =~ tr|\\|/|;
			if ($filename =~ /\/([^\/]*)$/) { $filename = $1; }
			$filename =~ s/[\r\n\x00\"]//g;
			# եǡɤ߹
			my $saved;
			if ($use_temp_dir) {
				my $file;
				if ( my $fh = $self->open_tmpfile( \$file ) ) {
					# ե뤬ץǤ顢ե˽
					my $size = $buffer->read_line($fh, $boundary, $file_max_size);
					close($fh);
					if (defined $self->{File_mode}) { chmod($self->{File_mode}, $file); }
					$saved=1;
					my %h;
					$form->{$name} = \%h;
					$h{tmp_file}   = $file;		# tmp file name
					$h{file_name}  = $filename;
					$h{file_size}  = $size;
				} else {
					$buffer->read_line(\$value, $boundary, 0);	# ǡɤ߼Τ
				}
			} else {
				# ѿɤ߹
				my $size = $buffer->read_line(\$value, $boundary, $file_max_size);
				my %h;
				$form->{$name} = \%h;
				$h{data}       = $value;	# tmp file name
				$h{file_name}  = $filename;
				$h{file_size}  = $size;
			}
		} else {
			$buffer->read_line(\$value, $boundary, $data_max_size);
			$self->form_data_check_and_save($form, $options, $name, $value);
		}
		## print "$name=$form->{$name}\n";	## debug
		# ǡν꤫ǧ
		$buffer->read_line(\$line, "\r\n", $header_max_size);
		if ($line eq '--') { $err=0; last; }
	}
	# ǡɤ߽
	## print "error code : $err\n";	## debug
	if ($err) {		# 顼ΤȤǡ̵
		$self->message('Multipart form read error'); return ;
	}

	# save
	$self->{POST} = 1;		# POST Ǥ뤳ȤϿ
	$self->{Form} = $form;

	# POST ץȤ exec 
	if ($self->{If_post_exec}) { $self->execute( $self->{If_post_exec} ); }
	return 1;
}

#-----------------------------------------------------------
# եΥǡå
#-----------------------------------------------------------
sub form_data_check_and_save {
	my ($self, $form, $options, $name, $val) = @_;
	$name =~ s/[\x00-\x08\x0a-\x1f]//g;
	my $type = substr($name,-4);
	if ($name eq 'checkbox.info') {
		$val =~ s/[\x00-\x1f]//g;
		if (!exists $form->{$val}) { $form->{$val}=undef; }
	} elsif ($name eq 'checkbox.notinfo') {
		$val =~ s/[\x00-\x1f]//g;
		if (!exists $form->{$val}) { $form->{$val}=1; }
	} elsif ($type ne '_bin') {	# ХʥǡǤϤʤ
		$val =~ s/[\x00-\x08\x0b\x0c\x0e-\x1f\x7f]//g;	# TAB LF CRʳ楳ɤ
		if ($self->{UA_code}) {	# ɽʸɤʸɤۤʤȤ
			my $jcode = $self->loadpm("Jcode");
			$jcode->from_to( \$val, $self->{UA_code}, $self->{System_coding} );
		}
		my $bytes = length($val);
		if ($type eq '_txt') {	# ƥȥꥢϤʤԤ
			$val =~ s/\r\n/\n/g;
			$val =~ tr/\r/\n/;
			my $txt_max_size = $options->{txt_max_size} || 65536;
			if ($txt_max_size && $bytes >$txt_max_size) { $val = substr($val, 0, $txt_max_size); }
		} elsif ($type eq '_int') {	# 
			if ($val ne '') { $val=int($val); if($val<0) { $val=0; } }
		} else {
			my $str_max_size = $options->{str_max_size} || 256;
			$val =~ s/[\r\n]//g;	# Ԥ
			if ($str_max_size && $bytes >$str_max_size) { $val = substr($val, 0, $str_max_size); }
		}
	}
	if ($type eq '_ary') {	# 
		if (!defined $form->{$name}) { $form->{$name} = []; }
		push(@{ $form->{$name} }, $val);
	} else {
		$form->{$name} = $val;
	}
}

#------------------------------------------------------------------------------
# CSRFк롼
#------------------------------------------------------------------------------
sub csrf_check {
	my ($self, $post_key) = @_;
	if ($self->{CSRF_no_check}) { return 0; }
	my $check_key = $self->{CSRF_check_key};
	if ($post_key ne '' && $post_key eq $check_key) { return 0; }

	# ԰פξ硢եΥǡ̵
	my $form = $self->{Form};
	$self->{POST} = 0;				# POST flag 򥯥ꥢ
	foreach(keys(%$form)) { delete $form->{$_}; }	# եǡƺ
	$self->message("This post may be CSRF attack");
	return 1;	# CSRF ?
}
###############################################################################
# Cookie
###############################################################################
#==============================================================================
# cookie õ
#==============================================================================
sub clear_cookie {
	my $self = shift;
	my ($name, $path, $domain) = @_;
	$self->put_cookie("$name=; expires=Thu, 1-Jan-1970 00:00:00 GMT;", $path, $domain);
}


#==============================================================================
# cookie ʸ󡢥ϥå򣱤Ĥcookie¸
#==============================================================================
sub set_cookie {
	my $self = shift;
	my ($name, $val, $expires, $path, $domain) = @_;
	if ($expires > 0) {
		$expires = ' expires='. $self->rfc_date($self->{TM} + $expires) . ';';
	} elsif ($expires) {	# ̵¡
		$expires = ' expires=Tue, 19-Jan-2038 00:00:00 GMT;';
	} else {		# 0 or ̤ʺåΤߡ
		$expires = '';
	}

	if (ref $val eq 'ARRAY') {
		# ¸
		my $ary = $val;
		$val = "\0\1";	# 0x00 0x01
		foreach (@$ary) { $val .= "\0" . $_; }
	} elsif (ref $val eq 'HASH') {
		# HASH¸
		my $h = $val;
		$val = "\0\2";	# 0x00 0x02
		while(my ($k, $v) = each(%$h) ) {
			$val .= "\0" . $k . "\0" . $v;
		}
	}

	$val =~ s/([^\w\-\/\.\@\~\*])/ '%' . unpack('H2', $1)/eg;
	$self->put_cookie("$name=$val;$expires", $path, $domain);
}

#==============================================================================
# cookie 
#==============================================================================
sub put_cookie {
	my ($self, $str, $path, $domain) = @_;
	if ($path   eq '') { $path   = $self->{Cookie_path};   }
	if ($domain eq '') { $domain = $self->{Cookie_domain}; }
	if ($self->{Is_w3m} && $domain =~ /^[\w\-]+\.[\w\-]+(\.[\w\-]+)$/
	 && index('.com.edu.net.org.gov.mil.int', $1)) {
		# see more info
		# http://www.sic.med.tohoku.ac.jp/~mladmin/w3m-dev/200502.month/4141.html
		$domain = '';
	}
	if ($path   ne '') { $path   = ' path='   . $path . ';';    }
	if ($domain ne '') { $domain = ' domain=' . $domain . ';';  }

	$self->print_header('Set-Cookie', "$str$path$domain");
}

###############################################################################
# HTTP, TCP/IPϢ
###############################################################################
#------------------------------------------------------------------------------
# 쥯 (RFC2616)
#------------------------------------------------------------------------------
sub redirect {
	my ($self, $uri) = @_;
	$uri =~ s/[\x00-\x1f]//g;	# ʸ
	my $status;
	if ($ENV{SERVER_PROTOCOL} eq 'HTTP/1.1' || $self->{Is_IE}) {
		$status = "303 See Other";	# HTTP/1.1, GET᥽åɤѹ
	} elsif ($ENV{REQUEST_METHOD} eq 'POST') {
		$status = "200 OK"; 		# redirectԲ
	} else {
		$status = "302 Found"; 		# HTTP/1.0, ᥽åѹʤ
	}
	if ($self->{Is_phone}) { $status="302 Found"; }
	# ХѥξURI˽񤭴
	if (! $self->{Redirect_use_relative_url} && index($uri, '://') < 0) {
		if (substr($uri,0,1) ne '/') { $uri = $self->{Basepath} . $uri; }
		$uri = $self->{Host_url} . $uri;
	}
	if ($status ne '200 OK') { $self->print_header('Location', $uri); }
	$self->print_header('Status', $status);
	$self->print_content_type('text/html');

	if ($self->{Is_phone}) {
		print "<html><body>-&gt;<a href=\"$uri\">reload</a></body></html>";
	} else {
		print <<HTML;
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<HTML><HEAD>
<TITLE>$status</TITLE>
<META HTTP-EQUIV="Refresh" CONTENT="0; url=$uri">
</HEAD><BODY>
<P><A HREF="$uri">Please move here</A>(redirect).<P>
</BODY></HTML>
HTML
	}
	$self->exit(0);
}

#------------------------------------------------------------------------------
# ۥ̾εհ
#------------------------------------------------------------------------------
sub resolve_host {
	my $self  = shift;
	my $force = shift;
	if (!$force && $ENV{REMOTE_HOST} ne '') { return ; }

	# հ
	my $ip = $ENV{REMOTE_ADDR};
	if ($ip eq '') { return ; }
	my $ip_bin = pack('C4', split(/\./, $ip));
	my $host   = gethostbyaddr($ip_bin, 2);
	if ($host eq '') { return ; }

	# 2Ű
	my @addr = gethostbyname($host);
	splice(@addr, 0, 4);	# [0]-[3] ΤƤ address ꥹȤΤ߻Ĥ
	my $flag = 1;
	foreach(@addr) {
		if ($_ eq $ip_bin) { $flag=0; last; }
	}
	if ($flag) { return ; }
	# 2Ű
	$ENV{REMOTE_HOST} = $host;
}

###############################################################################
# ¾
###############################################################################
#------------------------------------------------------------------------------
# EBXSSΥå
#------------------------------------------------------------------------------
# www.akiyan.com/blog/archives/2006/03/xsscssebcss.html
sub check_ebxss {
	my $self = shift;
	foreach(@_) {
		if (ord(substr($_,-1)) > 0x7f) { $_ .= ' '; }
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# URL XSSΥå
#------------------------------------------------------------------------------
sub check_url_xss {
	my $self = shift;
	foreach(@_) {
		if ($_ =~ /^\s*$/) { $_=''; next; }
		if (ord($_) != 0x2f && substr($_, 0, 2) ne './'
		 && substr($_, 0, 7) ne 'http://' && substr($_, 0, 8) ne 'https://') {
			$_ =~ s/&#(?:0*58|x0*3a);/:/;
			$_ =~ s/:/%3a/g;
			$_ = './' . $_;
		}
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# ϥåΥ
#------------------------------------------------------------------------------
sub dump_hash {
	my $self = shift;
	my ($format, $h) = @_;
	if (ref $format eq 'HASH') { $h=$format; $format="%k = %v<br>\n"; }

	my @ary;
	my $keys = $h->{_order};
	if (ref $keys ne 'ARRAY') {
		my @keys = sort {$a cmp $b} keys(%$h);
		$keys = \@keys;
	}
	foreach(@$keys) {
		my $x = $format;
		$x =~ s/%[Kk]/$_/g;
		$x =~ s/%[Vv]/$h->{$_}/g;
		push(@ary, $x);
	}
	return \@ary;
}

1;	# ޤʤ
