#!/usr/local/bin/perl
use strict;
#-------------------------------------------------------------------------------
# ǡ١ץ饰
#					(C)2005,2006 nabe / ABK project
#-------------------------------------------------------------------------------
package Satsuki::DB_pseudo;
use Satsuki::AutoLoader;
our $VERSION = '1.01';
our $DEBUG;	# ̤
our $filename_format = "%05d";
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	my ($ROBJ, $dir) = @_;

	$dir = $ROBJ->get_filepath($dir);
	if (!-e $dir) { $ROBJ->mkdir($dir); }
	$self->{ROBJ} = $ROBJ;	# root object save
	$self->{dir}  = $dir;	# directory

	# ǥե
	$DEBUG = 0;
	$self->{_RDBMS}            = 'pseudo DB';
	$self->{db_id}             = "$dir:";
	$self->{index_file}        = "#index.dat";
	$self->{index_backup_file} = "#index.backup.dat";
	$self->{file_ex}           = ".dat";

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}



###############################################################################
# ơ֥
###############################################################################
#------------------------------------------------------------------------------
# ơ֥¸߳ǧ
#------------------------------------------------------------------------------
sub get_table_lastmodifed {
	return &find_table( @_ );
}

#------------------------------------------------------------------------------
# ơ֥¸߳ǧ
#------------------------------------------------------------------------------
sub find_table {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($table) = @_;
	$table =~ s/\W//g;

	my $dir   = $ROBJ->get_filepath($self->{dir}) . $table . '/';
	my $index = $dir . $self->{index_file};
	if (!-e $index) {
		$self->{ROBJ}->update_modtime_by_file( $dir );
		if (-e "$dir$self->{index_backup_file}") { return 1; }	# Found
		return 0;	# Not found
	}
	return (stat($index)) [9];
}

###############################################################################
# ǡθ
###############################################################################
sub select {
	my $timer = $_[0]->{ROBJ}->{Timer};
	$timer && $timer->start('db');
	my $r = _select(@_);
	$timer && $timer->stop('db');
	return $r;
}

sub _select {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	my ($table, $h) = @_;
	$table =~ s/\W//g;
	$h->{hits}   = 0;				#  = 0

	my $db       = $self->load_index($table, undef, $h->{no_error});	# table array ref
	my $idx_only = $self->{"$table.index_only"} +0;				# index only flag
	if ($#$db < 0) { return $db; }

	#---------------------------------------------
	# ʸǡɤν
	#---------------------------------------------
	my $dir     = $self->{dir} . $table . '/';
	my $file_ex = $self->{file_ex};

	#---------------------------------------------
	# ޥå󥰾ν
	#---------------------------------------------
	my $mint_h = $h->{match_int};
	my @mints  = keys(%$mint_h);
	my $mstr_h = $h->{match_str};
	my $min_h  = $h->{min};
	my @mins   = keys(%$min_h);
	my $max_h  = $h->{max};
	my @maxs   = keys(%$max_h);
	my $flag_h = $h->{flag};
	my @flags  = keys(%$flag_h);
	my $in_col = $h->{match_in_col};
	my $in_val = $h->{match_in};
	# IS NULL ʸޥå󥰤
	foreach(@{ $h->{is_null} }) {
		$mstr_h->{ $_ }="";
	}
	my $not_null= $h->{is_not_null} || [];
	my @mstrs   = keys(%$mstr_h);
	my %in;
	if ($in_col && ref($in_val) eq 'ARRAY') {
		foreach(@$in_val) { $in{$_}=1; }
	}
	# ñʥǡФȽ
	my $limit = 0x1fffffff;
	if (! $h->{require_hits} && $h->{limit} ne '' && $h->{sort} eq '') {
		$limit = int($h->{limit}) -1 + int($h->{offset});
	}
	# Ⱦ
	my $sort  = $h->{sort};
	my $sort2 = $h->{sort2};

	# indexʳо or оݤʤǡ
	my $index_cols = {};
	my $idx = $self->{"$table.idx"};
	foreach(@$idx) { $index_cols->{$_} = 1; }
	my $load_all_data;
	if ((grep {! $index_cols->{$_}} (@mints,@mstrs,@mins,@maxs,@flags))
	 || ($sort ne '' && !$index_cols->{$sort}) || ($sort2 ne '' && !$index_cols->{$sort2})) {
		$load_all_data = 1;
		$db = [ map { $ROBJ->fread_hash_cached($dir . sprintf($filename_format, $_->{pkey}). $file_ex) } @$db ];
	}
	# 롼
	if ($#mints <= 0 && $#mstrs  <= 0 && $#maxs <= 0 && $#mins <= 0 && $#flags <= 0 && $#$not_null <= 0) {
		my $mint_key = $mints[0];
		my $mint     = $mint_h->{$mint_key};
		my $mstr_key = $mstrs[0];
		my $mstr     = $mstr_h->{$mstr_key};
		my $min_key  = $mins[0];
		my $min      = $min_h->{$min_key};
		my $max_key  = $maxs[0];
		my $max      = $max_h->{$max_key};
		my $flag_key = $flags[0];
		my $flag     = $flag_h->{$flag_key};
		my $nnul_key = $not_null->[0];
		my @newary;
		foreach (@$db) {
			if (defined $mint_key && $_->{$mint_key} != $mint) { next; }
			if (defined $flag_key && $_->{$flag_key} != $flag) { next; }
			if (defined $mstr_key && $_->{$mstr_key} ne $mstr) { next; }
			if (defined $min_key  && $_->{$min_key}  <  $min)  { next; }
			if (defined $max_key  && $_->{$max_key}  >  $max)  { next; }
			if (defined $nnul_key && $_->{$nnul_key} eq '')    { next; }
			if (defined $in_col   && !exists $in{$_->{$in_col}}) { next; }
			push(@newary, $_);
			if($#newary >= $limit) { last; }
		}
		$db = \@newary;
	} elsif ($#mints >= 0 || $#mstrs >= 0 || $#maxs >= 0 || $#mins >= 0) {
		my @newary;
		OUT_LOOP:
		foreach my $h (@$db) {
			foreach (@mints) {
				if ($h->{$_} != $mint_h->{$_}) { next OUT_LOOP; }
			}
			foreach (@mstrs) {
				if ($h->{$_} ne $mstr_h->{$_}) { next OUT_LOOP; }
			}
			foreach (@flags) {
				if ($h->{$_} != $flag_h->{$_}) { next OUT_LOOP; }
			}
			foreach (@mins) {
				if ($h->{$_} <  $min_h->{$_})  { next OUT_LOOP; }
			}
			foreach (@maxs) {
				if ($h->{$_} >  $max_h->{$_})  { next OUT_LOOP; }
			}
			foreach (@$not_null) {
				if ($h->{$_} eq '')            { next OUT_LOOP; }
			}
			if (defined $in_col && !exists $in{$_->{$in_col}})  { next OUT_LOOP; }
			## ξޥå
			push(@newary, $h);
			if($#newary >= $limit) { last; }
		}
		$db = \@newary;
	}
	if ($#$db < 0) { return $db; }
	#---------------------------------------------
	# Ƚ
	#---------------------------------------------
	if ($sort ne '' && $sort2 ne '') {
		if ($self->check_type_str($table, $sort)) {
			if ($h->{sort_reverse}) {
				if ($h->{sort2_reverse}) { $db = [ sort {$b->{$sort} cmp $a->{$sort} || $b->{$sort2} <=> $a->{$sort2}} @$db ]; }
						else     { $db = [ sort {$b->{$sort} cmp $a->{$sort} || $a->{$sort2} <=> $b->{$sort2}} @$db ]; }
			} else {
				if ($h->{sort2_reverse}) { $db = [ sort {$a->{$sort} cmp $b->{$sort} || $b->{$sort2} <=> $a->{$sort2}} @$db ]; }
						else     { $db = [ sort {$a->{$sort} cmp $b->{$sort} || $a->{$sort2} <=> $b->{$sort2}} @$db ]; }
			}
		} else {
			if ($h->{sort_reverse}) {
				if ($h->{sort2_reverse}) { $db = [ sort {$b->{$sort} <=> $a->{$sort} || $b->{$sort2} <=> $a->{$sort2}} @$db ]; }
						else     { $db = [ sort {$b->{$sort} <=> $a->{$sort} || $a->{$sort2} <=> $b->{$sort2}} @$db ]; }
			} else {
				if ($h->{sort2_reverse}) { $db = [ sort {$a->{$sort} <=> $b->{$sort} || $b->{$sort2} <=> $a->{$sort2}} @$db ]; }
						else     { $db = [ sort {$a->{$sort} <=> $b->{$sort} || $a->{$sort2} <=> $b->{$sort2}} @$db ]; }
			}
		}
	} elsif ($sort ne '') {
		if ($self->check_type_str($table, $sort)) {
			if ($h->{sort_reverse}) { $db = [ sort {$b->{$sort} cmp $a->{$sort}} @$db ]; }
					else    { $db = [ sort {$a->{$sort} cmp $b->{$sort}} @$db ]; }
		} else {
			if ($h->{sort_reverse}) { $db = [ sort {$b->{$sort} <=> $a->{$sort}} @$db ]; }
					else    { $db = [ sort {$a->{$sort} <=> $b->{$sort}} @$db ]; }
		}
	}

	#---------------------------------------------
	# ʸ
	#---------------------------------------------
	if (! $h->{require_hits} && $h->{limit} ne '') {
		$limit = int($h->{limit}) -1 + int($h->{offset});
	}
	if ($h->{search_cols}) {
		my $words = $h->{search_words};
		my $cols  = $h->{search_cols};
		my $do_load;
		if (! $load_all_data && grep {! $index_cols->{$_}} @$cols) {
			$do_load       = 1;
			$load_all_data = 1;
		}
		# ν
		my @words_reg;
		foreach(@$words) {
			my $x = $_;
			$x =~ s/([^0-9A-Za-z\x80-\xff])/"\\x" . unpack('H2',$1)/eg;
			$x = qr/$x/i;
			push(@words_reg, $x);
		}
		# 롼
		my @newary;
		SEARCH_WORD_LOOP:
		foreach $h (@$db) {
			if ($do_load) {
				$h = $ROBJ->fread_hash_cached($dir . sprintf($filename_format, $h->{pkey}). $file_ex);
			}
			foreach my $w (@words_reg) {
				my $flag=1;
				foreach (@$cols) {
					if ($h->{$_} =~ /$w/) { $flag=0; last; }
				}
				if ($flag) { next SEARCH_WORD_LOOP; }
			}
			push(@newary, $h);
			if($#newary >= $limit) { last; }
		}
		$db = \@newary;
	}
	if ($#$db < 0) { return $db; }

	#---------------------------------------------
	# Ͽ
	#---------------------------------------------
	# ֤Ƥ⹽ʤ̥⥸塼Υߥɻߤ
	if ($h->{require_hits}) {
		$h->{hits} = $#$db +1;
	}

	#---------------------------------------------
	# limit and offset
	#---------------------------------------------
	if ($h->{offset} ne '') {
		splice(@$db, 0, $h->{offset});
	}
	if ($h->{limit} ne '') {
		splice(@$db, $h->{limit});
	}

	#---------------------------------------------
	# all data load?
	#---------------------------------------------
	if (!$load_all_data) {
		my $cols = $h->{select_cols};	# index Υबɬ
		if (!$cols || (grep { !$index_cols->{$_} } @$cols)) {
			$db = [ map { $ROBJ->fread_hash_cached($dir . sprintf($filename_format, $_->{pkey}). $file_ex) } @$db ];
		}
	}

	return $db;
}

###############################################################################
# ֥롼
###############################################################################
#-------------------------------------------------------------------------------
# index Υ
#------------------------------------------------------------------------------
sub load_index {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	my ($table, $edit_flag, $no_error) = @_;
	if (! $edit_flag && defined $self->{"$table.tbl"}) {
		return $self->{"$table.tbl"};
	}

	# load
	my $dir   = $ROBJ->get_filepath( $self->{dir} . $table . '/' );
	my $index = $dir . $self->{index_file};
	if (!-e $index && -e $dir) { $self->index_rebilud( $table ); }
	my ($fh, $lines);
	if ($edit_flag) {	# Խե饰
		($fh, $lines) = $ROBJ->fedit_readlines($index);
		if ($#$lines < 0) {
			$ROBJ->fedit_exit($index, $fh);
			return undef;
		}
		$self->{"$table.lock"} = $fh;
	} else {
		if ($no_error) { $lines = $ROBJ->fread_lines_cached_no_error($index); }
			else   { $lines = $ROBJ->fread_lines_cached($index);          }
		if ($#$lines < 0) { return undef; }
	}

	# ǡ
	my $version = $self->{"$table.version"} = int(shift(@$lines));	# Version
	if ($version > 2) {
		$self->{"$table.index_only"} = int(shift(@$lines));
	} else {	# 
		$self->{"$table.index_only"} = $version;
	}
	if (substr($^O, 0, 5) eq 'MSWin') {	# patch for windows
		map { s/[\r\n]//g } @$lines;
	}
	$self->{"$table.serial"} = int(shift(@$lines));	# serial
	my $t = shift(@$lines); chomp($t);
	my @cols = split(/\t/, $t);		#  = ̾
	my (@num_cols, @flag_cols);
	if ($version > 2) {
		$t = shift(@$lines); chomp($t);
		@num_cols  = split(/\t/, $t);	#  = ͥ̾
		push(@num_cols,'pkey');
		$t = shift(@$lines); chomp($t);
		@flag_cols = split(/\t/, $t);	#  = flag̾
	}
	$t = shift(@$lines); chomp($t);
	my @idx_cols = split(/\t/, $t);		#  = index̾

	my @list;
	my $x;
	foreach $x (@$lines) {
		chomp($x);
		my @ary = split(/\t/, $x);
		my %h;
		foreach (@idx_cols) {
			$h{$_} = shift(@ary);	# TAB, Ԥν
		}
		push(@list, \%h);
	}
	$self->{"$table.tbl"}  = \@list;	# table ¸
	$self->{"$table.cols"} = \@cols;	# ̾¸
	$self->{"$table.idx"}  = \@idx_cols;	# index̾¸
	$self->{"$table.num"}  = \@num_cols;	# ͥ̾¸
	$self->{"$table.flag"} = \@flag_cols;	# ե饰̾¸

	return \@list;
}
#------------------------------------------------------------------------------
# ʸ󷿤å
#------------------------------------------------------------------------------
sub check_type_str {
	my ($self, $table, $column) = @_;
	if (!exists $self->{"$table.tbl"}) { $self->{ROBJ}->error("%s table not found!", $table); }
	
	my $num_cols  = $self->{"$table.num"}  || [];
	my $flag_cols = $self->{"$table.flag"} || [];

	foreach(@$num_cols, @$flag_cols) {
		if ($_ eq $column) { return 0; }
	}
	return 1;
}


#------------------------------------------------------------------------------
# ǥХ
#------------------------------------------------------------------------------
sub set_debug {
	my ($self, $flag) = @_;
	$DEBUG = $flag;
}

1;	# ޤʤ
