#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for WordPress-SQL
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
# http://wordpress.xwd.jp/
#    WordPressǡ١Υǡ¤ˤĤƤϡ°Υե򻲾ȤΤ
package Satsuki::Diary::ImportWordPressSQL;
use Time::Local;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# WordPress-SQLΥǡݡ
#------------------------------------------------------------------------------
sub import {
	my ($self, $diary_obj, $form) = @_;
	my $ROBJ = $self->{ROBJ};

	# ǡ
	my $import   = $form->{import};
	my $data     = $import->{data};
	my $filename = $import->{file_name};
	delete $form->{import};

	#----------------------------------------------------------------------
	# gzipŸ
	#----------------------------------------------------------------------
	if ($filename =~ /\.gz$/) {
		my $error;
		my $file;
		my $fh = $ROBJ->open_tmpfile( \$file );
		while(1) {
			my $file_size = $import->{file_size};
			if (!$import->{file_size} || !$fh) { $error=1; last; }
			# ե˽񤭽Ф
			if(syswrite($fh, $data, $file_size) != $file_size) {
				$error=2; last;
			}
			$data = undef;
			# gzip ⥸塼Υ
			my $gzip;
			eval { $gzip=$ROBJ->loadpm('Base::Gzip'); };
			if ($@) { $error=3; last; }
			# gzip Υǡ᤹
			my $max_size = $ROBJ->{Form_options}->{multipart_total_max_size} || 512*1024;
			my $size     = $gzip->zcat( $file, \$data, $max_size );
			if ($size < 1 || $size < $file_size) { $error=4; }
			last;
		}
		if ($fh) { close($fh); }
		if ($file) { unlink( $file ); }
		# 顼
		if ($error) {
			$ROBJ->message("Can't support %s file", 'gzip');
			return $error;
		}
	}

	#----------------------------------------------------------------------
	# ݡȽ
	#----------------------------------------------------------------------
	# ǡå
	my $check_data = substr($data, 0, 1024);
	if ($check_data !~ /\#\s*WordPress\s*MySQL\s*database\s*backup/i) {
		$ROBJ->message('Data format error (%s)', 'WordPress');
		return -1;
	}

	# ʸѴ
	if (! $form->{WPS_no_jcode}) {
		my $system_coding = $ROBJ->{System_coding};
		my $jcode = $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$data, '', $system_coding);
 	}

	# ơ֥ǡΥ
	$data =~ s/(\r\n|\r)/\n/g;
	my $wp_posts      = $self->load_mysql_table('wp_posts',      $data);
	my $wp_categories = $self->load_mysql_table('wp_categories', $data);
	my $wp_post2cat   = $self->load_mysql_table('wp_post2cat',   $data);
	my $wp_comments   = $self->load_mysql_table('wp_comments',   $data);
	my $wp_users      = $self->load_mysql_table('wp_users',      $data);
	undef $data;

	# ǡù
	my %post2catname;
	{
		my %cat2name = map { $_->{cat_ID} => $_->{cat_name} } @$wp_categories;
		map { $post2catname{ $_->{post_id} } ||= $cat2name{ $_->{category_id} } } @$wp_post2cat;
	}
	my %uid2name = map { $_->{ID} => $_->{display_name} } @$wp_users;
	undef $wp_categories;
	undef $wp_post2cat;
	undef $wp_users;

	# ȤȤ˳Ǽ
	my $no_auth_com  = $form->{WPS_no_auth};		# ǧȤ򥤥ݡȤʤ
	my $no_spam_com  = $form->{WPS_no_spam};		# SPAMȤ򥤥ݡȤʤ
	my %postid2comments;
	foreach(@$wp_comments) {
		my $status = $_->{comment_approved};
		if (($status eq '0'    && $no_auth_com)		# ǧ°ν񤭹
		 || ($status eq 'spam' && $no_spam_com) ) {	# SPAM°ν񤭹
		 	next;
		}
		my $ary = $postid2comments{ $_->{comment_post_ID} } ||= [];
		push(@$ary, $_);
	}
	undef $wp_comments;

	# ѹ֤ʤɥեλ
	my $change_hour     = $form->{WPS_change_hour_int};
	my $import_static   = $form->{WPS_import_static};	# Ūڡ򥤥ݡ
	my $static_category = $form->{WPS_static_category};	# Ūڡʬ
	$static_category  ||= $form->{WPS_static_category_input};	# ľܻ

	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	my %parser_cache;
	my $days    = 0;
	my $imports = 0;
	foreach my $day (@$wp_posts) {
		#-------------------------------------------------------------
		# ɤ߽Ф
		#-------------------------------------------------------------
		my %diary;
		my $status = $day->{post_status};
		if ($status eq 'publish' || $status eq 'static' && $import_static) {
			$diary{enable} = 1;

		} elsif ($status eq 'draft' || $status eq 'private') {
			$diary{enable} = 0;

		} else {	# if attachment/object
			next;
		}
		my $post_id = $day->{ID};
		if (!$post_id) { next; }
		$days ++;
		# ƥ
		$diary{category} = $post2catname{ $post_id };
		if ($status eq 'static' && $static_category) {	# ŪƥĤΥƥ
			$diary{category} = $static_category;
		}
		# ȥ
		$diary{title} = $day->{post_title};
		# 񤭹
		$diary{name}  = $uid2name{ $day->{post_author} };
		# վ
		my $gmt = $day->{post_date_gmt};
		if ($gmt !~ /^(\d\d\d\d)\-(\d\d)\-(\d\d) (\d\d):(\d\d):(\d\d)$/) { next; }
		eval { $diary{tm} = Time::Local::timegm($6, $5, $4, $3, $2-1, $1); };
		if (!$@) {
			# ˤĤ
			my $h = $ROBJ->time2timehash( $diary{tm}, $change_hour );
			$diary{year} = $h->{year};
			$diary{mon}  = $h->{mon};
			$diary{day}  = $h->{day};
		} elsif ($status eq 'draft') {
			# 顼
			$ROBJ->message('Not set date draft "%s", import to day of "%s"', $diary{title}, '2099-01-10');
			$diary{year} = 2099;
			$diary{mon}  = 1;
			$diary{day}  = 10;
		} else {
			next;	# 顼
		}
		# /ȥåХåε
		$diary{allow_com} = 0;
		$diary{allow_tb}  = 0;
		if ($day->{comment_status} eq 'open') { $diary{allow_com}=1; }
		if ($day->{ping_status}    eq 'open') { $diary{allow_tb} =1; }

		#-------------------------------------------------------------
		# ʸνȲù
		#-------------------------------------------------------------
		my $body = "\n" . $day->{post_content};
		if ($body =~ /^\n\s*$/) { next; }
		$body =~ s/\\r\\n|\\r|\\n/\n/g;
		# ³ɤ൭Υ
		$body =~ s/\n====\n/\n ====\n/g;
		# ³ɤ൭֤
		$body =~ s/\n<!\-\-more\-\->/\n====\n/;
		$body = substr($body, 1);
		# ѿ˳Ǽ
		$diary{text}   = $body;
		$diary{parser} = 'simple_p';

		#-------------------------------------------------------------
		# ȤȥȥåХåν
		#-------------------------------------------------------------
		my @comments;
		my @trackbacks;
		my $this_comments = $postid2comments{ $post_id };
		foreach(@$this_comments) {
			my %h;
			# վ
			my $gmt = $_->{comment_date_gmt};
			if ($gmt !~ /^(\d\d\d\d)\-(\d\d)\-(\d\d) (\d\d):(\d\d):(\d\d)$/) { next; }
			eval { $h{tm} = Time::Local::timegm($6, $5, $4, $3, $2-1, $1); };
			# ե饰
			if ($_->{comment_approved} eq '1') { $h{enable}=1; } else { $h{enable}=0; }
			# ³ԡƼԾ
			$h{ip}    = $_->{comment_author_IP};
			$h{agent} = $_->{comment_agent};
			$h{url}   = $_->{comment_author_url};
			#-------------------------------------------------------------
			# ʸ
			#-------------------------------------------------------------
			my $body = $_->{comment_content};
			# <br> to \n
			$body =~ s/<br.*?>|\\r\\n|\\r|\\n/\n/g;
			# 
			$ROBJ->tag_delete($body);

			if ($body =~ /^\s*$/) { next; }
			if ($_->{comment_type} ne 'trackback') {
				#-------------------------------------------------------------
				# Ȥν
				#-------------------------------------------------------------
				$h{name}  = $_->{comment_author};
				$h{email} = $_->{comment_author_email};
				$h{text}  = $body;	# ʸ
				push(@comments, \%h);
				next;
			}
			#-------------------------------------------------------------
			# ȥåХåν
			#-------------------------------------------------------------
			$h{blog_name} = $_->{comment_author};
			if ($body =~ /^(.*?)\.\.\.\n\n(.*)/) {
				$h{title} = $1;
				$body     = $2;
			}
			$body =~ s/ \(more\.\.\.\)$/.../g;	# Ǹ (more...)  ... ֤
			$h{excerpt} = $body;
			push(@trackbacks, \%h);
		}

		#-------------------------------------------------------------
		# ǡ¸
		#-------------------------------------------------------------
		if (! $diary_obj->save_diary(\%parser_cache, \%diary, \@comments, \@trackbacks)) {	# ¸
			$imports ++;
		}
	}
	$diary_obj->{exists_diaries} = $days;
	$diary_obj->{import_diaries} = $imports;
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# -----פǶڤ줿νޤǥ
#------------------------------------------------------------------------------
sub load_section {
	my $ary = shift;
	my @section;
	while(@$ary) {
		my $data = shift(@$ary);
		if ($data eq '-----') { last; }
		push(@section, $data);
	}
	if ($section[ $#section ] eq '') { pop(@section); }	# ǸζԤڤΤ
	return \@section;
}

#------------------------------------------------------------------------------
# MySQLΥץǡǡ
#------------------------------------------------------------------------------
sub load_mysql_table {
	my $self       = shift;
	my $table_name = shift;
	# CREATE TABLE
	if ($_[0] !~ /(\nCREATE TABLE `$table_name`.*?\n\).*?;)/s) { return ; }
	my $create_sql = $1;
	# INSERT TABLE
	if ($_[0] !~ /(\nINSERT INTO `$table_name`.*?)\n(\# End of data|\n)/s) { return ; }
	my $insert_sql = $1;
	# ơ֥륫β
	$create_sql =~ s/'(\\'|.)*?'//g;		# ʸ
	my @ary = split("\n", $create_sql);
	my @columns;
	foreach(@ary) {
		if ($_ =~ /^\s*`(\w+)`/) { push(@columns, $1); }
	}
	# ǡβ
	@ary = split("\n", $insert_sql);
	my @table;
	foreach my $line (@ary) {
		if ($line !~ /INSERT INTO `\w+` VALUES \((.*)\)\s*;\s*$/) { next; }
		my $values = $1 . ",";
		my @vals;
		# ʸ
		my @strbuf;
		$values =~ s/'((\\'|.)*?)'/push(@strbuf, $1), "\#$#strbuf"/eg;
		# ʬ
		my $c=0; my %h;
		$values =~ s/([\w\#]+)\s*,/$h{ $columns[$c++] } = $1, ''/eg;
		# ɥǡù
		foreach(@columns) {
			if    ($h{$_} =~ /^null$/i) { $h{$_} = undef; }
			elsif ($h{$_} =~ /^\#(\d+)$/) {
				$h{$_} = $strbuf[$1];
				$h{$_} =~ s/\\'/'/g;	# \' ᤹
			}
			# $self->{ROBJ}->debug("$_ = $h{$_}");
		}
		push(@table, \%h);
	}
	return \@table;
}


1;
