use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::TextParser::Satsuki.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::TextParser::Satsuki ();
package Satsuki::TextParser::Satsuki;
###############################################################################
# ü쥿ΰ
###############################################################################
#------------------------------------------------------------------------------
# ΰü쥿
#------------------------------------------------------------------------------
sub load_tags {
	my $self      = shift;
	my $mode      = shift;		# 0:٤ 1:Τ 2:html֥åΤ
	my $size      = shift || 40;
	my $separator = shift || '<br>&nbsp;&nbsp;';

	my $ROBJ  = $self->{ROBJ};
	my $jcode = $ROBJ->loadpm('Jcode');
	my $code  = $ROBJ->{System_coding};

	# ߤ
	my $tags    = $self->{tags};
	my $titles  = $self->{titles};
	my $options = $self->{options};

	my @keys = sort keys(%$tags);
	my @ary;
	foreach(@keys) {
		if (ord($_) == 0x3d) { next; }		# Ƭ = ̵
		my $tag = $tags->{$_};
		if ($tag->{alias} || $tag->{html}) { next; }	# alias or html ̵
		my $url = $tag->{data};
		# html tag֥å֤
		my $html_block = substr($url,0,1) eq '<';
		if ($html_block && $mode==1 || !$html_block && $mode==2) { next; }
		if (!defined $url) { next; }			# ̤
		if (ref($url)) { $url=undef; }
		my $url2 = $jcode->jsubstr($code, $url, 0, $size);
		$url     = $jcode->jsubstr($code, $url, $size);
		while($url ne '') {
			$url2 .= "\x01" . $jcode->jsubstr($code, $url, 0, $size);
			$url   = $jcode->jsubstr($code, $url, $size);
		}
		$url2 =~ s/>/&gt;/g;
		$url2 =~ s/</&lt;/g;
		$url2 =~ s/\x01/$separator/g;
		
		my %h = %$tag;
		$h{name} ||= $_;
		$h{url} = $url2;
		$h{title} =~ s/^\s*title="(.*)"$/$1/;
		push(@ary, \%h);
	}
	return \@ary;
}

#------------------------------------------------------------------------------
# ΰhtmlִ
#------------------------------------------------------------------------------
sub load_htmltags {
	my $self      = shift;
	my $separator = shift || ', ';
	my $ROBJ = $self->{ROBJ};

	my $tags  = $self->{tags};
	my @keys = sort keys(%$tags);
	my @ary;
	foreach(@keys) {
		if (ord($_) == 0x3d) { next; }	# Ƭ = ̵
		my $tag = $tags->{$_};
		if (! $tag->{html}) { next; }		# html ʳ̵

		my ($html_tag, $class) = split('\.', $tag->{html});
		my %h;
		$h{name}      = $_;
		$h{html}      = $html_tag;
		$h{class}     = $class;
		$h{attribute} = $tag->{attribute};
		push(@ary, \%h);
	}
	return \@ary;
}

#------------------------------------------------------------------------------
# ΰalias
#------------------------------------------------------------------------------
sub load_aliases {
	my $self      = shift;
	my $separator = shift || ', ';
	my $ROBJ = $self->{ROBJ};

	my %aliases;
	my $tags  = $self->{tags};
	while(my($k,$v) = each(%$tags)) {
		if (ord($k) == 0x3d) { next; }	# Ƭ = ̵
		my $alias = $v->{alias};
		if (! $alias) { next; }	# alias ʳ̵
		# ̾
		my $ary   = $aliases{$alias} ||= [];
		push(@$ary, $k);
	}

	my @ary;
	my @keys = sort keys(%aliases);
	foreach(@keys) {
		my %h;
		$h{tag}    = $_;
		$h{alias}  = join($separator, @{ $aliases{$_} });
		push(@ary, \%h);
	}
	return \@ary;
}

###############################################################################
# ¾Υ롼
###############################################################################
#------------------------------------------------------------------------------
# ܼκ
#------------------------------------------------------------------------------
sub make_tableofcontents {
	my $self = shift;
	my ($with_section_number) = @_;
	my $sections = $self->{sections};

	my @ary;
	my $in_subsection = '';
	push(@ary, "<ul class=\"title\">\n");
	foreach(@$sections) {
		my $section    = $_->{section};
		my $subsection = $_->{subsection};
		if (! $in_subsection && $subsection) {	#  subsection
			push(@ary, "\t<ul class=\"section\">\n");
			$in_subsection = "\t";
		} elsif ($in_subsection && ! $subsection) {
			push(@ary, "\t</ul>\n");
			$in_subsection = '';
		}
		my $section_num = '';
		if ($with_section_number) {
			if ($subsection) { $section_num="$section.$subsection "; } else { $section_num="$section "; }
		}
		push(@ary, "$in_subsection\t<li><a href=\"#$_->{name}\">$section_num$_->{title}</a>");
	}
	if ($in_subsection) { push(@ary, "\t</ul>\n"); }
	push(@ary, "</ul>\n");

	return join('', @ary);
}


#------------------------------------------------------------------------------
# ǡμ
#------------------------------------------------------------------------------
sub get_sections {
	my $self = shift;
	return $self->{sections};
}





1;
