use strict;
#-------------------------------------------------------------------------------
# TAG escape module
#						(C)2005-2006 nabe / nabe@abk.nu
#-------------------------------------------------------------------------------
package Satsuki::TextParser::TagEscape;
our $VERSION = '1.10';
#-------------------------------------------------------------------------------
# ץȥ ǧ°
#-------------------------------------------------------------------------------
my %PROTOCOL_CHECK = (
	href => 1, src => 1, site => 1, cite => 1, background => 1, action => 1
);
#-------------------------------------------------------------------------------
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ} = shift;

	$self->init(@_);	# 

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# 
###############################################################################
#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub init {
	my $self = shift;
	my ($file) = @_;
	my $ROBJ   = $self->{ROBJ};

	my $lines = $ROBJ->fread_lines_cached($file);
	my %tag_allow;
	my @allow_tags;
	while(@$lines) {
		my $x = shift(@$lines);
		chomp($x);
		if ($x eq '' || ord($x) == 0x23) { next; }	# '#'ǻϤޤԤϥ
		my ($tag, $attri) = split(/\s+/, $x, 2);
		if ($attri eq '') {		# ɸĤΤ
			$tag_allow{$tag} = [];
		} elsif ($attri eq '*') {	# ٤Ե
			$tag_allow{$tag} = {};
		} else {
			my @ary = split(/\s*,\s*/, $attri);
			$tag_allow{$tag} = \@ary;
		}
		if ($tag_allow{_module_start}) { last; }
	}
	# ⥸塼ǡΥ
	my %modules;
	my ($name, $html);
	# ⥸塼եΥ
	my $include  = [];
	my $mod_file = $tag_allow{_include_module}->[0];
	if ($mod_file ne '') {
		# Хѥ
		$mod_file = $ROBJ->get_relative_path($file, $mod_file);
		$include  = $ROBJ->fread_lines_cached($mod_file);
	}
	push(@$lines, "\n");
	foreach(@$lines, @$include) {
		chomp($_);
		if (ord($_) == 0x23) { next; }	# '#'ǻϤޤԤϥ
		if (defined $name) {
			if ($_ ne '') { $html .= "$_\n"; next; }
			# ⥸塼
			chomp($html);
			$modules{$name} = $html;
			$name = $html = undef;
		}
		if (ord($_) != 0x2a) { next; }		# * ǻϤޤʤԤ̵
		# *name Ȥ
		$name = substr($_,1);
	}
	# ¸
	if ($tag_allow{_base}) { $self->{allow_base} = join(', ', @{ $tag_allow{_base} }); }
	if ($tag_allow{_protocol}) {
		my $p = $tag_allow{_protocol};
		$self->{allow_protocol} = join(', ', @$p);
		$tag_allow{_protocol} = { map {$_=>1} @$p };
	}
	$self->{allow_anytag}        = (exists $tag_allow{_allow_anytag});
	$self->{force_absolute_path} = (exists $tag_allow{_force_absolute_path});
	$self->{force_absolute_uri}  = (exists $tag_allow{_force_absolute_uri});
	$self->{tag_allow} = \%tag_allow;
	$self->{modules}   = \%modules;

	# module <@xxx> ʸɾ
	if (exists $tag_allow{_eval_module_skelton}) {
		foreach(keys(%modules)) {
			$modules{$_} =~ s/<@([\w\.]+)>/&get_object($ROBJ, $1)/eg;
		}
	}
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub escape {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $inp  = shift;
	my $url_wrapper = shift;
	## $ROBJ->{Timer}->start('tag');

	# 
	my @out;
	my $tag;
	my $tag_list   = $self->{tag_allow};
	my $mod_list   = $self->{modules};
	my $tag_check  = (! $self->{allow_anytag});	# debug
	my $attris_all = $tag_list->{_base};
	my $protocols  = $tag_list->{_protocol};
	my $comment    = $tag_list->{_comment};
	my $style_secure = $tag_list->{_style_secure};
	# ХѥURI񤭴
	my $abs_uri    = (exists $tag_list->{_force_absolute_uri});
	my $abs_path   = (exists $tag_list->{_force_absolute_path}) || $abs_uri;
	my $basepath   = $ROBJ->{Basepath};
	my $server_url;
	if ($abs_uri) { $server_url = $ROBJ->{Server_url}; }

	# 
	# escape, \x05-\x08ϥ桼˲
	$inp =~ s/[\x01-\x08]//g;

	### Ƚ or 
	my @comments;
	if (exists $tag_list->{_comment}) {		# 
		$inp =~ s/<!--(.*?)-->/push(@comments,$1),"\x01$#comments\x01"/seg;
		foreach(@comments) {	# securityк
			$_ =~ s/--/==/g;
			$_ =~ s/^([\$\@])/ $1/;
		}
	} else {		# 
		$inp =~ s/<!--.*?-->//sg;
	}

	# & 
	&escape_amp( $inp );	# &  &amp;

	### print "Content-Type: text/plain;\n\n";
	my @modules;
	$inp =~ s[</module>][<module_end>]eg;
	while($inp =~ /^(.*?)<([\@\w\.]+(?:\s*\w+(?:=".*?"|='.*?'|[^\s>]*))*)\s*(\/)?>(.*)/s) {
		my $x   = $1;		# ʬ
		$inp    = $4;		# Ĥ
		my $tag = $2;		# ʬ
		my $tag_end='';
		if ($3) { $tag_end=" /"; }	#  /> ʬ
		my $tagmark = substr($tag, 0, 1);

		my $y;
		$x   =~ s[</(.+?)\s*>][
				$y=$1; (!$tag_check || ($y=~tr/A-Z/a-z/,exists $tag_list->{$y})) && "\x02/$y\x03"
			]seg;
		$x   =~ s/</&lt;/g;
		$x   =~ s/>/&gt;/g;
		&escape_amp( $x );	# &  &amp;
		push(@out, $x);
		$tag =~ s/</&lt;/g;
		$tag =~ s/>/&gt;/g;

		# ʸǧĤ°ʬ
		my @x; my %at;
		while($tag =~ /\G[\n\s]*([\@\$\w\.]+)(?:="(.*?)"|='(.*?)'|=[^\s"'>]+|)/sg) {
			my $x=$1;
			$x =~ tr/A-Z/a-z/;	# ʸѴ
			push(@x, $x);
			if ($2 ne '' || $3 ne '') { $at{$x}="$2$3"; }
		};
		my $tag_name = shift(@x);

		# ⥸塼륿
		if ($tag_name eq 'module' || $tag_name eq 'module_end') {
			my $data     = {};
			my $data_uri = {};
			my $data_int = {};
			my $name;
			if ($tag_name eq 'module') {
				foreach(@x) {
					my $v = $at{$_};
					$v =~ s/</&lt;/g;
					$v =~ s/>/&gt;/g;
					$v =~ s/\"/&quot;/g;
					$v =~ s/\'/&#39;/g;
					$data->{$_} = $v;
					# uri 󥳡
					$v =~ s/([^\.\/\~\*\-\w\#:;=\+\?&% ])/'%' . unpack('H2',$1)/eg;
					$v =~ s/script:/script%3a/i;
					$data_uri->{$_} = $v;
					# ʸǡ
					$data_int->{$_} = int($v);
				}
				$name = $data->{name};
				if (exists $mod_list->{"${name}::end"}) {	# block ⥸塼롩
					push(@modules, $data, $data_uri, $data_int);
				}
			} else {
				$data_int = pop(@modules) || {};
				$data_uri = pop(@modules) || {};
				$data     = pop(@modules) || {};
				$name     = $data->{name} . '::end';
			}
			# ִ
			my $html = $mod_list->{ $name };
			$html =~ s/\#\{(\w+)(?:\|([^\}]*))?\}/   (exists $data->{$1}    ) ? $data->{$1}     : $2/eg;
			$html =~ s/\$\{(\w+)(?:\|([^\}]*))?\}/   (exists $data_uri->{$1}) ? $data_uri->{$1} : $2/eg;
			$html =~ s/\$int\{(\w+)(?:\|([^\}]*))?\}/(exists $data_int->{$1}) ? $data_int->{$1} : $2/eg;
			$html =~ s/\$(euc|sjis|utf8)\{(\w+)\}/ &code_conv($ROBJ,$data->{$2},$1) /eg;
			push(@out, $html);
			next;
		}

		# Ĥ줿
		my $attris = $tag_list->{$tag_name};
		if ($tag_check && !defined $attris) { next; }
		my @y = ();

		my ($last_at, $last_val);
		foreach(@x) {
			my $v = $at{$_};
			if ($_ eq '') { next; }	# °̵

			if (ref($attris) eq 'ARRAY') {	# ϥåѴ
				$attris = { map { $_ => 1 } @$attris };
				map { $attris->{$_}=1 } @$attris_all;
			}
			if ($tag_check && !$attris->{$_}) { next; }	# °̵

			# ̵° selected
			if (!exists $at{$_}) { unshift(@y, $_); next; }
			# ʸ
			my $v = $at{$_};
			if ($v eq '') { next; }	# °̵ͤ

			# 󥯥ץȥǧ href, src ʤɡXSSк
			if ($PROTOCOL_CHECK{$_} && ($tag_check || $v !~ /^javascript:/i)) {
				if ($url_wrapper) { $v = &$url_wrapper($_, $v); }	# URLåѡ
				$v =~ s/&#(?:0*58|x0*3a);/:/;
				# Υ󥳡
				$v =~ s/([^\x01-\x08\.\/\~\*\-\w\#:;=\+\?&%])/'%' . unpack('H2',$1)/eg;
				my $b = index($v, ':');
				my $c = index($v, '?');
				if ($b >= 0 && ($c<0 || $b<$c)) {
					$b = substr($v, 0, $b);
					if (!$protocols->{$b}) { next; }	# ̵
				} elsif (ord($v) == 0x23) {	# Ƭ #
					# anchor ϤΤޤ
				} elsif ($abs_path) {
					# Хѥ/URIХѥ/URI˽񤭴
					if (ord($v) != 0x2f) { $v = $basepath . $v; }	# / ǻϤޤäƤʤ
					$v =~ s|([^\.])\./|$1|g;
					$v = $server_url . $v;
				} elsif (ord($v) != 0x2f && substr($v, 0, 2) ne './') {
					$v = './' . $v;
				}
			}

			# 륷ȻXSSк
			if ($tag_check && $style_secure && $_ eq 'style') {
				$v =~ s/[\\\@\x00-\x1f\x80-\xff]//g;		# ASCIIʸʳ
				# ʸν
				while($v =~ m[/\*|\*/&#|script|java|exp|eval|cookie|include]i) {
					$v =~ s[/\*|\*/&#|script|java|exp|eval|cookie|include][]ig;
				}
			}
			# ĥ
			if ($tag_check || index($v,'"')<0) {
				$v =~ s/\"/&quot;/g;
				push(@y, "$_=\"$v\"");
			} else {
				push(@y, "$_='$v\'");
			}
			$last_at  = $_;
			$last_val = $v;
		}
		unshift(@y, $tag_name);
		if ($#y >= 0) {
			if ($tag_check && ord(substr($last_val, -1)) > 0x7f) {	# XSSк
				if ($last_at eq 'title' || $last_at eq 'alt') {
					$y[$#y] = "$last_at=\"$last_val \"";	# spaceղ
				} else {
					push(@y, 'xss=""');	# dummy°ղ
				}
			}
			push(@out, '<' . join(' ', @y) . $tag_end . '>');
		}
	}
	$inp =~ s[</(.+?)>][(!$tag_check || exists $tag_list->{$1}) && "\x02/$1\x03"]seg;
	$inp =~ s/</&lt;/g;
	$inp =~ s/>/&gt;/g;
	my $out = join('', @out) . $inp;

	# 
	$out =~ s/\x01(\d+?)\x01/<!--$comments[$1]-->/g;
	# Ĥ
	$out =~ tr/\x02\x03/<>/;

	# CSSXSSк
	if (exists $tag_list->{_escape_cssxss}) {
		$out =~ s/{/&#123;/g;
	}
	# 
	## $ROBJ->debug(int($ROBJ->{Timer}->stop('tag')*10000)/10);
	return $out;
}

#------------------------------------------------------------------------------
# ̾饪֥Ȥμ
#------------------------------------------------------------------------------
sub get_object {
	my ($obj, $name) = @_;
	$name =~ s/[^\w\.]//g;		# Ⱦѱѿ _ . ʳʸ
	if ($name eq '') { return ; }	# 顼̤֤

	my @ary = split(/\./, $name);
	foreach(@ary) {
		$obj = $obj->{$_};
	}
	return $obj;
}

#------------------------------------------------------------------------------
# ʸѴ
#------------------------------------------------------------------------------
my $jcode;
sub code_conv {
	my ($ROBJ, $value, $code) = @_;
	$jcode ||= $ROBJ->loadpm('Jcode');
	$jcode->from_to(\$value, $ROBJ->{System_coding}, $code);
	$ROBJ->form_encode( $value );
	return $value;
}

#------------------------------------------------------------------------------
# & ɽ
#------------------------------------------------------------------------------
sub escape_amp {
	$_[0] =~ s/&(\w+;|\#\d+;)/\x05$1/g;
	$_[0] =~ s/&/&amp;/g;
	$_[0] =~ tr/\x05/&/;
	return $_[0];
}


#------------------------------------------------------------------------------
# ĥꥹȤ
#------------------------------------------------------------------------------
sub load_allowtags {
	my ($self, $skelton) = @_;
	my $tags = $self->{tag_allow};
	my @keys = sort keys(%$tags);

	my @ary;
	foreach(@keys) {
		if (substr($_, 0, 1) eq '_') { next; }
		my %h;
		$h{tag}    = $_;
		$h{attris} = join(", ", @{ $tags->{$_} });
		push(@ary, \%h);
	}
	return \@ary;
}

1;	# ޤʤ
