use strict;
#------------------------------------------------------------------------------
# ˡץ饰
#                                                (C)2009/08 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_mahjong;
###############################################################################
# ܽ
###############################################################################
# Ȥ
# [mj:1m2m3m 4p5rp6p 7s8s9s ton ton sp haku haku hakuy]
#
# Τ褦˽񤭤ޤڡ϶ڤˤʤޤʤƤ⹽ޤ
# 1m9m ߻ҡʥޥ󥺡
# 1p9p ҡʥԥ󥺡
# 1s9s ҡʥ
# 5rm, 5rp, 5rs = ֥ɥ
# ton nan sha pei = 
# haku hatu chun  = ϥ
# ura = ΢
# sp  = 1ʬΥڡ
# Ǹ'y'ĤȲפˤʤޤ
#
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags  = shift;
	$tags->{'mj'}     = {data=> \&mahjong };
	$tags->{'mj:img'} = {data=>'public/mahjong/'};
}
###############################################################################
# 롼
###############################################################################
my %jihai=(
# 
'ton'=>1,'nan'=>1,'sha'=>1,'pei'=>1,'haku'=>1,'hatu'=>1,'tyun'=>1,
# ΢ڡ
'ura'=>1,'sp'=>1,
# alias
'hatsu'=>'hatu','chun'=>'tyun');
my %suji=('m'=>'man', 'p'=>'pin', 's'=>'sou');

#------------------------------------------------------------------------------
# mjˡ
#------------------------------------------------------------------------------
sub mahjong {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $tags = $parser_obj->{tags};
	my $ROBJ = $parser_obj->{ROBJ};
	my $replace_data = $parser_obj->{replace_data};

	# mode å
	my $tag_name = $tag->{name};
	my $argc     = $tag->{argc};
	my $mode     = $ary->[ ($argc || 1) ];
	if (exists $tags->{"$tag_name#$mode"}) {
		$tag  = $tags->{"$tag_name#$mode"};
		$mode = undef;
	}

	# decode
	my @pi;
	my $line=shift(@$ary);
	my $jihai='';
	my $s=0;
	while($s<length($line)) {
		my $x = substr($line, $s++, 1);
		if (0x30 <= ord($x) && ord($x) < 0x3a) {
			my $r='';
			my $yoko='';
			my $y = substr($line, $s++, 1);
			if ($y eq 'r') {	# ֥ɥ
				$r='r'; $y=substr($line, $s++, 1);
			}
			if ($suji{$y}) {
				if (substr($line, $s, 1) eq 'y') {	# 
					$yoko='y'; $s++;
				}
				push(@pi, "$yoko$x$r$suji{$y}");
			}
			$jihai='';
			next;
		}
		# spaceФڤȸʤ
		if ($x eq ' ') { $jihai=''; next; }
		$jihai .= $x;
		if (!$jihai{$jihai}) { next; }

		# 
		my $yoko='';
		if (substr($line, $s, 1) eq 'y') {	# 
			$yoko='y'; $s++;
		}
		if ($jihai{$jihai} != 1) { $jihai=$jihai{$jihai}; }
		push(@pi, "$yoko$jihai");
		$jihai='';
	}

	# 
	my $dir = $tags->{'mj:img'}->{data};
	my $name = $parser_obj->make_name($ary, 'mahjong');

	my $img = join('', map {"<img class=\"mahjong\" src=\"$dir$_.gif\">"} @pi);
	return "<div class=\"mahjong\">$img</div>";
}

1;
