////////////////////////////////////////////////////////////////////////////////
// ơ֥륽ȥץ (Javascript) Ver.1.04
//   Copyright (C) 2008 ꤫/꤫
////////////////////////////////////////////////////////////////////////////////

/* provided objects/methods
 *   method enableall()
 *   method enable( table )
 */

/* How to use
 *   tablesort.enableall();
 *     or
 *   tablesort.enable( table );
 */

////////////////////////////////////////
var tablesort = {
	i: 0,
	makeName: function(){
		return '_TABLESORT_' + (tablesort.i++);
	},
	tables: new Array(),
	enableall: function(){
		var T = document.getElementsByTagName('TABLE');
		for(var i in T){
			this.enable(T[i]);
		}
	},
	enable : function(tbl){
		if(!tbl || !tbl.getElementsByTagName) return false;

		// check table header
		var th = tbl.getElementsByTagName('thead');
		if(!th) return false;
		th = th[0];

		// regist
		var id = tablesort.makeName();
		var table = tablesort.tables.push({
			'asc': 0,
			'table': tbl,
			'thead': th,
			'last': null
		});

		// set event handler
		var headers = th.getElementsByTagName('th');
		for(var i = 0; i < headers.length; i++){
			tablesort.addEvent(headers[i], 'click', tablesort.sort);
			if(tablesort._isNumeric(tbl, i))
				tablesort.addClass(headers[i], '_TABLESORT_NUM_');
		}

		return table;
	},
	_isNumeric: function(tbl, i){
		var count = 5; // check 5 records

		var obj = tbl.getElementsByTagName('TBODY');
		if(!obj) return false;
		obj = obj[0];
		var trs = obj.getElementsByTagName('TR');

		var re = new RegExp(/^(\-|\+)?\d+/);
		var tds, t;
		for(var j = 0; j < count && trs[j] != undefined; j++){
			tds = trs[j].getElementsByTagName('TD');
			if(! tds[i]) return false;
			t = tds[i].innerText || tds[i].textContent;
			if(!t || ! t.match(re)) return false;
		}
		if(j < count) return false; // can not check 5 records
		return true;
	},
	_getTableInfo: function (obj){
		for(var i in tablesort.tables){
			if(tablesort.tables[i]['table'] == obj)
				return tablesort.tables[i];
		}
		return null;
	},
	sort: function(e){
		var elem = e.srcElement || e.target; // th
		var doc = elem.ownerDocument;

		// get table info
		var table = tablesort._getTableInfo(tablesort._getParentNode(elem, 'TABLE'));
		if(!table) return false;

		// search sort colomn
		var headers = table['thead'].getElementsByTagName('th');
		var col = -1;
		for(var i in headers){
			if(headers[i] === elem){
				col = i;
				break;
			}
		}
		if(col == -1) return false;

		// check type
		var type = 'str';
		if(tablesort.hasClassMatch(headers[col], 'num')) type = 'num';

		// compare method
		var comp;
		if(table['last'] == col) table['asc'] = 1 - table['asc'];
		else                     table['asc'] = 0;
		table['last'] = col;
		comp = '_compare_' + type + (table['asc'] ? '_asc' : '_dec');

		var tb = table['table'].getElementsByTagName('tbody');
		if(!tb) return false;
		tb = tb[0];

		// sort
		var trs = tb.getElementsByTagName('tr');
		var td;
		var ary = new Array();
		var cache = new Array();
		for(var i = 0; i < trs.length; i++){
			td = trs[i].getElementsByTagName('td');
			var val1 = td[col].innerText || td[col].textContent;
			ary[i] = {'index':i, 'value':val1};
			cache[i] = trs[i];
		}
		while(tb.firstChild)
			tb.removeChild(tb.firstChild);
		ary.sort(tablesort[comp]);
		for(var i in ary){
			if(i % 2){
				tablesort.delClass(cache[ary[i].index], 'odd');
				tablesort.addClass(cache[ary[i].index], 'even');
			}else{
				tablesort.delClass(cache[ary[i].index], 'even');
				tablesort.addClass(cache[ary[i].index], 'odd');
			}
			tb.appendChild(cache[ary[i].index]);
		}
		return true;
	},

	// compare methods
	_compare_str_asc: function(val1, val2){
		return (val2.value.toLowerCase() == val1.value.toLowerCase()) ? 0 : (val2.value.toLowerCase() < val1.value.toLowerCase()) ? -1 : 1;
	},
	_compare_str_dec: function(val1, val2){
		return (val1.value.toLowerCase() == val2.value.toLowerCase()) ? 0 : (val1.value.toLowerCase() < val2.value.toLowerCase()) ? -1 : 1;
	},
	_compare_num_asc: function(val1, val2){
		return (parseFloat(val2.value) - parseFloat(val1.value));
	},
	_compare_num_dec: function(val1, val2){
		return (parseFloat(val1.value) - parseFloat(val2.value));
	},

	////////////////////////////////////
	// some useful methods
	addEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;

		if(obj.addEventListener) obj.addEventListener(name, func, false);
		else if(obj.attachEvent) obj.attachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, func);

		return true;
	},
	delEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;

		if(obj.removeEventListener) obj.removeEventListener(name, func, false);
		else if(obj.detachEvent)    obj.detachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, '');

		return true;
	},
	hasClassMatch : function (obj, name) {
		if(!obj) return false;

		var re = new RegExp(name, "i");
		if(obj.className.match(re))
			return true;
		return false;
	},
	hasClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		var found = false;
		for(var i in classes){
			if(classes[i] == name){
				found = true;
				break;
			}
		}

		return found;
	},
	addClass : function (obj, name) {
		if(!obj || !obj.className) return false;

		var classes = obj.className.split(' ');
		var found = false;
		for(var i in classes){
			if(classes[i] == name){
				found = true;
				break;
			}
		}
		if(!found)
			classes.push(name);

		obj.className = classes.join(' ');
		return true;
	},
	delClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		for(var i in classes){
			if(classes[i] == name){
				classes[i] = '';
				break;
			}
		}

		obj.className = classes.join(' ');
		return true;
	},
	_getParentNode: function(obj, tag){
		if(!obj) return null;
		if(!tag) return obj.parentNode;
		var tagname = obj.tagName || obj.localName;
		while(obj && tagname && tagname != tag){
			obj = obj.parentNode;
			tagname = obj.tagName || obj.localName;
		}
		return obj;
	}
}

